//
//      OggVorbis Library iKvȂ̂ˁj
//      Coder : Ko-Ta

unit OggDataLib;

interface

uses Windows, SysUtils, StrUtils, Classes, FFTLib, math, OggWuvorbisLib,
     mmsystem, uAGC;

type TALOGGSemaphore=class
  protected
    FSema : THANDLE;
  public
    constructor Create(name:String; n:Integer=1);
    destructor  Destroy; override;

    procedure   Lock;
    procedure   UnLock;
end;

//==============================================================================
// 萔
const
  OGG_FFTSAMPLE = 256;
  _AO_16BitVolumeMax = 32767;
  
type
  _TOggTime=Single;
  TPLAYSTATE = (psNONE,psSTOP,psPLAY,psLOOP);

// EQtF[h\
type TOggEQ = record
  sNow : Single;
  sSet : Single;
  sAdd : Single;
end;
// ʃtF[h\
type TOggVolume = record
  iNow : Int64;
  iSet : Int64;
  iAdd : Int64;
end;
// PAN@\
type TOggPan = record
  iNow : Int64;
  iSet : Int64;
  iAdd : Int64;
end;

// Waveg`ꊇǂݍݗp
type TLRWavePack16 = packed record
  L : SmallInt;
  R : SmallInt;
end;
type PLRWavePack16 = ^TLRWavePack16;
type TLRWavePack32 = packed record
  L : Integer;
  R : Integer;
end;
type PLRWavePack32 = ^TLRWavePack32;

// OggVorbis[v\
type TOggLoop = packed record
  BeginTime : _TOggTime;
  EndTime   : _TOggTime;
  Count     : Integer;
end;
// OggHeadder
//type TAlphaOggHed = packed record
//  Hed : array[0..7]  of Char;
//  Loop: array[0..15] of TOggLoop;
//end;

// OggVorvisǗNX
type TOggData = class
  private

  protected
    FSemaphore    : TALOGGSemaphore;
    FLoaded       : Boolean;
    FOggStream    : TMemoryStream;
    FOggOffset    : Int64;
    FOggVorbisFile: wu_OggVorbis_File;
    FLoopFlag     : Boolean;        //[vĐĂ邩H
    FPlayFlag     : Boolean;        //ĐĂ邩H
    FWaveBuffer   : TMemoryStream;  //RenderingBuffer
    FWaveBufferSize : Integer;
    FWaveBufferPos,FPreWaveBufferPos: DWORD;          //RenderingPos
    FLastRendTime    : Int64;     //ŌRenderingꂽ
    FLastRendOggTime : _TOggTime; //ŌRenderingꂽȎ
    FPreOutputTime: Single;
    FLoopCount    : array[0..15] of Integer;   //[vJEg
    FTempFormatBuf: array of SmallInt;         //TvOLkp
    FTempRend16Buf: array of SmallInt;         //tH[}bgϊp

    FPrePlayState : TPLAYSTATE;
    FTotalTime : Single;
    FTotalSize : Int64;
    FOggChannels   : Integer;
    FOggRate       : Integer;
    FOggVendor     : String;
    FOggUserComment: TStringList;
    FOggTotalSize  : Int64;

    FVolume       : TOggVolume;
    FPan          : TOggPan;
    FMasterVolume : Integer;
    FChannelVolume: Integer;
                                //CRCUp
    PreRWave : array[0..OGG_FFTSAMPLE div 1 -1] of Single;
    PreLWave : array[0..OGG_FFTSAMPLE div 1 -1] of Single;

    PreNoiseRWave,PreNoiseLWave : Integer; //mCYp

    FEQ : array[0..255] of TOggEQ;   //EQ

    function    _DivideText(const t, s:String; SpaceCut:Boolean; CommentCut:Boolean; n:Integer):TStringList;
    procedure   OggThreadLock;
    procedure   OggThreadUnLock;
    function    RenderingToPointerOgg(ptr:Pointer; len16:Integer):Integer;
    function    RenderingToPointer4096(d:Pointer; Len:Integer; NowTime:Single; Format32Bit:Boolean=FALSE):Integer;
    function    OggReadWaveFormat(dptr:Pointer; ReadLen:Integer):Integer;
    procedure   LPPCharToStringList(sl:TStringList; p:LPPChar);
    procedure   GetOggInfo;
    procedure   GetLoopInfo;
    procedure   ApplyEQ(d:Pointer; Len:Integer);
    function    Harmite2(const x:array of Single; xx: Single; n: Integer): Single;
    function    Hermite( p0, p1, p2, p3, aRate: Single; tr1: Single = 1.0; tr2: Single = 1.0 ): Single;
    function    _Round(x:Single):Integer;

  public
    // [v
    LoopData   : array[0..15] of TOggLoop;

    // FFT Class
    FFT1,FFT2 :TFFT;
    //AGC
    AGC1 : TAGC;

    // GtFNgW
    EffectValue : array[0..15] of Single;

    constructor Create(Len16:Integer);
    destructor  Destroy; override;
    function    GetUseMemorySize:Integer;    //gp

    //
    procedure   Init;
    //t@Cǂݍ
    //function    LoadLoop(ss:TMemoryStream):Boolean;
    function    GetComment(name:String):TStringList;
    function    LoadOgg(ss:TMemoryStream):Boolean; overload;
    function    LoadOgg(Filename:String):Boolean; overload;
    function    LoadOgg2(ss:TStream):Boolean; overload;
    //function    SaveAlphaOgg(Filename:String):Boolean;
    //Waveg`_O
    function    RenderingToPointer(d:Pointer; Len:Integer; TimeFix:Integer=0; Format32Bit:Boolean=FALSE; Lock:Boolean=TRUE):Integer;
    function    Rendering(TimeFix:Integer=0):Integer;
    //V[N
    function    TimeTell(Lock:Boolean=TRUE):Single;
    procedure   TimeSeek(t:Single; Lock:Boolean=TRUE);
    function    SeekAble:Boolean;
    //ĐE~
    procedure   Play(Loop:Boolean; Lock:Boolean=TRUE);
    procedure   Stop(Lock:Boolean=TRUE);
    procedure   Pause(Lock:Boolean=TRUE);
    //ʑ
    procedure   SetVolume(v:SIngle=1.0; t:Single=0.0);
    procedure   SetMasterVolume(v:Single);
    procedure   SetChannelVolume(v:Single);
    function    GetNowVolume(Lock:Boolean=TRUE):Single;   //݂̉
    function    GetSetVolume(Lock:Boolean=TRUE):Single;   //ڕW̉
    function    GetMasterVolume:Single;
    function    GetChannelVolume:Single;
    //Pab
    procedure   SetPan(v:Single=0.0; t:Single=0.0);
    function    GetNowPan:Single;
    function    GetSetPan:Single;
    //AGC
    //Gain...ʁHHH
    //Rate...ωʁHHH
    //Target...ʂグl
    procedure   SetAGC(Vol:Single=1.0); overload;
    procedure   SetAGC(Gain:Single; Rate:Single; Target:Integer; Quiet:Integer); overload;
    //EQ
    procedure   SetEQ(h:Integer; v:Single); overload;
    procedure   SetEQ(h:Integer; v,t:Single); overload;
    function    GetNowEQ(h:Integer):Single;
    function    GetSetEQ(h:Integer):Single;
    function    GetEQ:Boolean;
    procedure   SetEQ16(v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,v13,v14,v15,v16, t : Single);
    procedure   SetEQ8(v1,v2,v3,v4,v5,v6,v7,v8, t:Single);
    procedure   SetEQ4(v1,v2,v3,v4, t:Single);
    //[v
    function    GetLoopCount(n:Integer):Integer;
    procedure   SetLoopCount(n,l:Integer);
    //ԃXLbv
    procedure   WhiteSkip(v:Integer);
    //A^CWaveVolume擾i덷j
    function    GetOutputWavePos: Integer;
    function    GetOutputSum:Single; overload;
    function    GetOutputSum(c:Integer):Single; overload;
    procedure   GetOutputGraph(d:PSingle);
    function    GetOutputTime:Single;
    //ԃtO
    function    GetPlayState(Lock:Boolean=TRUE) : TPLAYSTATE;
    function    GetNowPlayState(Lock:Boolean=TRUE) : TPLAYSTATE;
    //
    function    Memory  : Pointer;  //Waveg`i[|C^
    function    Offset  : Pointer;  //_OWaveg`̐擪AhX
    function    PreOffset : Pointer;
    //
    property    TotalTime:Single read FTotalTime;
    property    TotalSize:Int64 read FTotalSize;
    property    OggChannels:Integer read FOggChannels;
    property    OggRate:Integer read FOggRate;
    property    OggVendor:String read FOggVendor;
    property    OggUserComment:TSTringList read FOggUserComment;
    property    OggTotalSize:Int64 read FOggTotalSize;
end;

function OggToMemoryStream(ss:TStream):TMemoryStream; overload;
function OggToMemoryStream(filename:String):TMemoryStream; overload;

implementation

const
  _SEEKZERO = 0.000;
  _WHITESKIPTIME = 0.2;
  _AO_VOLUMEMUL = $100000000 * $100;   //64Bit

//------------------------------------------------------------------------------
// Oggf[^Waveg`ɕϊ
function OggToMemoryStream(ss:TStream):TMemoryStream; overload;
var
  OggData : TOggData;
  ss2,Buf : TMemoryStream;
  Len     : DWORD;
begin
  RESULT := NIL;
  //O
  if (_VorbisfileDll=nil)then exit;
  if (ss = nil)then exit;
  // OggDataǂݍ܂
  ss.Position := 0;
  ss2 := TMemoryStream.Create;
  ss2.CopyFrom(ss,0);
  ss2.Position := 0;
  OggData := TOggData.Create(44100);
  OggData.LoadOgg(ss2);              //ss2͋zB
  OggData.SetVolume(1.0);
  OggData.Play(FALSE,FALSE);
  Len := OggData.TotalSize;
  //ꍇ͂ƒ߂
  if (Len < 1024*32)then Len := 1024*32;
  if (Len mod 1024 <> 0)then Len := Len + (1024 - (Len mod 1024));
  // WJpobt@̐
  Buf := TMemoryStream.Create;
  Buf.SetSize(Len);
  ZeroMemory(Buf.Memory,buf.Size);
  OggData.RenderingToPointer(Buf.Memory,OggData.TotalSize);
  //J
  OggData.Free;

  RESULT := Buf;
end;

function OggToMemoryStream(filename:String):TMemoryStream; overload;
var
  ss : TMemoryStream;
begin
  ss := TMemoryStream.Create;
  ss.LoadFromFile(filename);
  RESULT := OggTomemoryStream(ss);
  ss.Free;
end;


{ TOggDecoder }
//------------------------------------------------------------------------------
// 
constructor TOggData.Create(Len16:Integer);
var
  i   : Integer;
begin
  FSemaphore := TALOGGSemaphore.Create('');

  // UserComment
  FOggUserComment := TStringList.Create;

  // FFT Class ̐
  FFT1 := TFFT.Create(OGG_FFTSAMPLE);
  FFT2 := TFFT.Create(OGG_FFTSAMPLE);
  //AGC
  AGC1 := TAGC.Create;

  // Waveg`p(32Bit)
  FWaveBuffer := TMemoryStream.Create;
  FWaveBuffer.SetSize(Len16*2);
  FWaveBufferSize := FWaveBuffer.Size;
  //FXȕϊp̉obt@Ɏgp
  SetLength(FTempFormatBuf,4096);
  SetLength(FTempRend16Buf,4096);

  //GtFNgpۑg`obt@
  for i:=0 to OGG_FFTSAMPLE div 4 - 1 do
  begin
    PreRWave[i] := 0.0;
    PreLWave[i] := 0.0;
  end;

  // ꂢɂƂ
  Init;

  // EQݒ
  for i:=0 to 255 do SetEQ(i,1.0);

  // ʐݒ
  SetVolume(1.0);
  SetPan(0.0);
  SetMasterVolume(1.0);
  SetChannelVolume(1.0);
end;

//------------------------------------------------------------------------------
// 
destructor TOggData.Destroy;
begin
  // LCL
  Init;

  // Waveg`ێ̈̊J
  FWaveBuffer.Free;                //

  // UserComment
  OggUserComment.Free;

  // DSL Class ̉
  FFT1.Free;
  FFT2.Free;
  //AGC
  AGC1.Free;

  //FThreadList.Free;
  FSemaphore.Free;

  inherited Destroy;
end;

//------------------------------------------------------------------------------
// ꂢς
procedure TOggData.Init;
var
  i : Integer;
begin
  OggThreadLock;

  Stop(FALSE);

  // OggXe[^X
  FOggUserComment.Clear;
  FOggVendor   := '';
  FOggChannels := 0;
  FOggRate     := 0;
  FOggTotalSize := 0;

  FTotalTime:= 0.0;
  FTotalSize:= 0;
  FPreOutputTime := 0;

  FLoaded := FALSE;

  // Oggkf[^
  if (FOggStream <> nil)then
  begin
    _VorbisfileDll.wu_ov_clear(FOggVorbisFile);   //OggData.Free͏Ɏsidl
    FOggStream := nil;
  end;
  
  //̈̏
  Zeromemory(FWaveBuffer.Memory,FWaveBufferSize);

  // VorbisFilef[^
  ZeroMemory(@FOggVorbisFile,sizeof(wu_OggVorbis_File));

  //Loop̏
  for i:=0 to 15 do
  begin
    LoopData[i].BeginTime := 0;
    LoopData[i].EndTime := 0;
    LoopData[i].Count := 0
  end;

  OggThreadUnLock;

  //AGC
  AGC1.Init;
  SetAGC(0.0); //
end;

//------------------------------------------------------------------------------
// ǂݍ(FileName & TMemoryStream)
function TOggData.LoadOgg(Filename: String): Boolean;
var
  ms : TMemoryStream;
begin
  Result := FALSE;
  if (FileExists(Filename)=FALSE)then exit;
  ms := TMemoryStream.Create;
  ms.LoadFromFile(Filename);
  ms.Position := 0;
  Result := LoadOgg(ms);
end;

function TOggData.LoadOgg(ss: TMemoryStream): Boolean;
begin
  RESULT := FALSE;
  if (ss = nil)then exit;
  //Yɂ
  Init;
  //Xg[Ⴄ
  FOggStream := ss;
  FOggOffset := ss.Position;
  if (_VorbisfileDll.wu_ov_open_callbacks(Pointer(FOggStream),FOggVorbisFile,nil,0) < 0)then
  begin
    if (FOggStream <> nil)then FOggStream.Free;
    FOggStream := nil;
    raise ERangeError.CreateFmt('t@C̓ǂݍ݂Ɏs',[]);
    exit;
  end;

  OggThreadLock;
  //
  GetOggInfo;
  //Loop𒸂
  GetLoopInfo;
  //[htOTRUEɃZbg
  FLoaded := TRUE;
  OggThreadUnLock;


  Result := TRUE;
end;



//------------------------------------------------------------------------------
// OggFilȅ
procedure TOggData.GetOggInfo;
var
  FPComment : LPwu_vorbis_comment;
  FPInfo    : LPwu_vorbis_info;
begin
  FPComment := LPwu_vorbis_comment(_VorbisfileDll.wu_ov_comment(FOggVorbisFile,-1));
  FPInfo    := LPwu_vorbis_info(_VorbisfileDll.wu_ov_info(FOggVorbisFile,-1));

  FOggVendor     := FPComment.vendor;
  LPPCharToStringList(FOggUserComment,FPComment.user_comments);
  FOggChannels   := FPInfo.channels;
  FOggRate       := FPInfo.rate;
  FOggTotalSize  := _VorbisfileDll.wu_ov_pcm_total(FOggVorbisFile,-1);

  FTotalTime  := _VorbisfileDll.wu_ov_time_total(FOggVorbisFile,-1);
  FToTalSize  := _VorbisfileDll.wu_ov_pcm_total(FOggVorbisFile,-1) *2*2;
end;

//------------------------------------------------------------------------------
//LPPCharStringList֕ϊ
procedure TOggData.LPPCharToStringList(sl:TStringList; p: LPPChar);
var
  pp: LPPChar;
  s : String;
begin
  pp:= p;
  while (PChar(pp^) <> nil)do
  begin
    s := pchar(pp^);
    s := Utf8ToAnsi(s);
    sl.Add(s);
    inc(pp);
  end;
end;

//------------------------------------------------------------------------------
// Waveg`
function TOggData.RenderingToPointer(d: Pointer; Len, TimeFix: Integer; Format32Bit,Lock: Boolean): Integer;
var
  n,a : Integer;
  tt : Single;
begin
  //Lock
  if (Lock)then OggThreadLock;
  
  FPrePlayState := GetPlayState(FALSE);

  //ʂODOȂ~Ă܂܂傤
  if ((GetNowVolume(FALSE)<0.01)and(GetSetVolume(FALSE)<0.01))then Pause(FALSE);
  
  //ǂݍ܂ĂȂꍇ
  //t~Ԃ̏ꍇ
  if ((FLoaded = FALSE)or(FPlayFlag=FALSE)or(FOggStream=nil))then
  begin
    ZeroMemory(d,Len);
    result := 0;
    if (Lock)then OggThreadUnLock;
    exit;
  end;

  //
  FLastRendTime := TimeGetTime;
  FLastRendTime := FLastRendTime - TimeFix;
  //Ȏ
  FLastRendOggTime := _VorbisfileDll.wu_ov_time_tell(FOggVorbisFile);

  n := Len;
  while (n>0)do
  begin
    if (Format32Bit)then tt := FLastRendOggTime+(Len-n)*(1/(44100*4*2))
                    else tt := FLastRendOggTime+(Len-n)*(1/(44100*2*2));
    a := RenderingToPointer4096(d,n,tt,Format32Bit);
    if (a<1)then break;  //End of
    n := n - a;
    inc(pchar(d),a);
  end;

  //I[ɒBꍇ͎cZeroŖ߂
  if (n>0)then ZeroMemory(d,n);

  RESULT := Len-n;

  //UnLock
  if (Lock)then OggThreadUnLock;
end;

function TOggData.RenderingToPointer4096(d:Pointer; Len: Integer; NowTime:Single; Format32Bit:Boolean):Integer;
  function _OggRendering(dptr:Pointer; len16:Integer):Integer;
  var
    ll : _TOggTime;
    f : Boolean;
    i,a : Integer;
    dd : Pointer;
  begin
    //16Bit_O
    RESULT := 0;
    dd := dptr;
    f := FALSE;
    ll := len16*(1/(44100*2*2));
    for i:=0 to 15 do
    begin
      with LoopData[i] do
      begin
        //[vI_(EndTime)ɒBǂH
        if ((Count>FLoopCount[i])or(Count=-1))then
          if ((NowTime+ll)>=EndTime)then
            if (NowTime<=EndTime)then
            begin
              if (Count<>-1)then inc(FLoopCount[i]);
              a := _Round((EndTime-NowTime)*(44100*2*2));
              a := a and $8FFFFFFC;
              if (a>len16)then a := len16;
              RESULT := RenderingToPointerOgg(dd,a);                                //EndTime܂Ń_O
              inc(pchar(dd),a);                                                     //]|C^i߂
              _VorbisfileDll.wu_ov_time_seek(FOggVorbisFile,BeginTime);             //BeginTime܂ŃV[N
              FPreOutputTime := 0;
              RESULT := RESULT + RenderingToPointerOgg(dd,len16-a);                 //c_O
              f := TRUE;
            end;
        //[vn_茻݈ʒuOȂ΃JEgZbg
        if (EndTime < NowTime)then FLoopCount[i] := 0;
      end;
    end;
    //[vɊYȂ烌_O
    if not(f)then RESULT := RenderingToPointerOgg(dd,len16);    //16BitRendering
  end;
  function _VolumeApply(dptr,sptr:Pointer; len16:Integer; Format32Bit:Boolean):Integer;
  var
    sLR : PLRWavePack16;
    dLR32 : PLRWavePack32;
    dLR16 : PLRWavePack16;
    i,n   : Integer;
    FVol,MVol,RPan,LPan: Integer;
    ll,rr,vvL,vvR : Integer;
  begin
    //ʂ𔽉f
    sLR := sptr;
    dLR32 := dptr;
    dLR16 := dptr;
    MVol:= FMasterVolume * FChannelVolume div 256;
    FVol:= (FVolume.iNow div (_AO_VOLUMEMUL div 256));
    LPan:= 256-(FPan.iNow div (_AO_VOLUMEMUL div 256));
    RPan:= 512-LPan; //256+(FPan.iNow div (_AO_VOLUMEMUL div 256));
    if (LPan>256)then LPan := 256;
    if (RPan>256)then RPan := 256;
    vvL := FVol * MVol * LPan div 65536;
    vvR := FVol * MVol * RPan div 65536;
    n  := (len16 div 4)-1;
    for i:=0 to n do
    begin
      //Volume
      with FVolume do
      begin
        if (iAdd<>0)then
        begin
          if (abs(iSet-iNow)<abs(iAdd))then
          begin
            iNow := iSet;
            iAdd := 0;
          end;
          iNow := iNow + iAdd;
          
          FVol:= (iNow div (_AO_VOLUMEMUL div 256));
          vvL := FVol * MVol * LPan div 65536;
          vvR := FVol * MVol * RPan div 65536;
        end;
      end;
      //Pan
      with FPan do
      begin
        if (iAdd<>0)then
        begin
          if (abs(iSet-iNow)<abs(iAdd))then
          begin
            iNow := iSet;
            iAdd := 0;
          end;
          iNow := iNow + iAdd;

          LPan:= 256-(FPan.iNow div (_AO_VOLUMEMUL div 256));
          RPan:= 512-LPan;  //256+(FPan.iNow div (_AO_VOLUMEMUL div 256));
          if (LPan>256)then LPan := 256;
          if (RPan>256)then RPan := 256;
          vvL := FVol * MVol * LPan div 65536;
          vvR := FVol * MVol * RPan div 65536;
        end;
      end;

      ll :=  Integer(sLR^.L) * vvL div 256;
      rr :=  Integer(sLR^.R) * vvR div 256;

      if (Format32Bit)then
      begin
        dLR32^.L:= ll;
        dLR32^.R:= rr;
        inc(sLR);
        inc(dLR32);
      end
      else
      begin
        if (ll<-_AO_16BitVolumeMax)then ll := -_AO_16BitVolumeMax;
        if (ll> _AO_16BitVolumeMax)then ll :=  _AO_16BitVolumeMax;
        if (rr<-_AO_16BitVolumeMax)then rr := -_AO_16BitVolumeMax;
        if (rr> _AO_16BitVolumeMax)then rr :=  _AO_16BitVolumeMax;
        dLR16^.L:= SmallInt(ll);
        dLR16^.R:= SmallInt(rr);
        inc(sLR);
        inc(dLR16);
      end;
    end;
    if (Format32Bit)then RESULT := len16*2
                    else RESULT := len16;
  end;                  
var
  dd : Pointer;
  ll : Integer;
begin
  RESULT := 0;
  if ((FLoaded=FALSE)or(FPlayFlag=FALSE))then exit;

  if (len>4096)then len := 4096;

  dd := @FTempRend16Buf[0];
  ZeroMemory(dd,4096 div 2 * 2);
  //Ogg(16bit)
  if (Format32Bit)then ll := _OggRendering(dd,Len div 2)  //2{ɐL̂ŃfR[h1/2ł悢
                  else ll := _OggRendering(dd,Len);
  if (ll<1)then exit;
  //EQ(16bit)
  ApplyEQ(dd,ll);
  //AGC(16bit)
  AGC1.Rendering(dd,ll);

  //Volume/Pan/Bitϊ
  RESULT := _VolumeApply(d,dd,ll,Format32Bit);
end;

//------------------------------------------------------------------------------
// ݂̎Ԃ擾
function TOggData.TimeTell(Lock:Boolean): Single;
begin
  if (Lock)then OggThreadLock;

  if (FOggStream = nil)then
    result := 0.0
  else
    result := _VorbisfileDll.wu_ov_time_tell(FOggVorbisFile);

  if (Lock)then OggThreadUnLock;
end;

//------------------------------------------------------------------------------
// ĐJn
procedure TOggData.Play(Loop,Lock:Boolean);
begin
  if (Lock)then OggThreadLock;
  FPlayFlag := TRUE;
  FLoopFlag := Loop;
  if (Lock)then OggThreadUnLock;
  //OiT T
  //Volume0.0ɃZbgčĐꍇ
  //if (GetPlayState<psPLAY)then
  //  if (GetSetVolume < 0.001)then SetVolume(1.0);
end;

//------------------------------------------------------------------------------
// ~
procedure TOggData.Stop(Lock:Boolean);
var
  i : Integer;
begin
  if (Lock)then OggThreadLock;

  Pause(FALSE);

  FLastRendOggTime:=0.0;
  FPreOutputTime := 0;

  TimeSeek(0.0,FALSE);

  for i:=0 to 15 do
    FLoopCount[i] := 0;

  ZeroMemory(FWaveBuffer.Memory,FWaveBufferSize);

  if (Lock)then OggThreadUnLock;
end;

//------------------------------------------------------------------------------
// w莞ԂɃWv
procedure TOggData.TimeSeek(t: Single; Lock:Boolean);
var
  tt : Single;
begin
  if (Lock)then OggThreadLock;
  
  if (FLoaded = FALSE)then
  begin
    if (Lock)then OggThreadUnLock;
    exit;
  end;

  //if (FOggVorbisFile.ready_state <> 4)then exit;
  tt := t;
  if (tt < _SEEKZERO)then tt := _SEEKZERO;
  if (tt > TotalTime)then tt := TotalTime;
  if (abs(TimeTell(FALSE)-tt)>_SEEKZERO)then
  begin
    if (SeekAble)then _VorbisfileDll.wu_ov_time_seek(FOggVorbisFile,tt);
  end;
  FPreOutputTime := 0;

  if (Lock)then OggThreadUnLock;
end;

procedure TOggData.SetVolume(v, t: Single);
var
  vv : Single;
begin
  OggThreadLock;

  vv := v;
  if (vv < 0.0)then vv := 0.0;
  if (vv > 64.0)then vv := 64.0;

  with FVolume do
  begin
    if (t < 0.01)then
    begin
      //ɉʂ𔽉f
      iSet := Trunc(_AO_VOLUMEMUL*vv);
      iNow := iSet;
      iAdd := 0;
    end
    else
    begin
      //tF[h
      iSet := Trunc(_AO_VOLUMEMUL*vv);
      iAdd := Trunc((iSet-iNow)/(t*44100));
    end;
  end;

  OggThreadUnLock;
end;

//------------------------------------------------------------------------------
// ݂̉ʂԂ
function TOggData.GetNowVolume(Lock:Boolean): Single;
begin
  if (Lock)then OggThreadLock;
  result := FVolume.iNow / _AO_VOLUMEMUL;
  if (Lock)then OggThreadUnLock;
end;

//------------------------------------------------------------------------------
// ݒ肵ʂԂ
function TOggData.GetSetVolume(Lock:Boolean): Single;
begin
  if (Lock)then OggThreadLock;
  result := FVolume.iSet / _AO_VOLUMEMUL;
  if (Lock)then OggThreadUnLock;
end;

//------------------------------------------------------------------------------
// [v擾
function TOggData.GetLoopCount(n: Integer): Integer;
begin
  result := 0;
  if (n > 15)then
    exit
  else
    result := FLoopCount[n];
end;

//------------------------------------------------------------------------------
// [vvOύX
procedure TOggData.SetLoopCount(n, l: Integer);
begin
  if (n > 15)then
    exit
  else
    FLoopCount[n] := l;
end;

//------------------------------------------------------------------------------
//ݏo͂Ă鉹ʂԂ
function TOggData.GetOutputSum: Single;
begin
  result := GetOutputSum(2);
end;

//`lw肵Ď擾B
//ch ... 0.Left / 1.Right / 2.Both
function TOggData.GetOutputSum(c: Integer): Single;
var
  WavPos    : Integer;
  SLR       : PLRWavePack32;
  BufMem    : DWORD;
  BufSize   : Integer;
  i         : Integer;
  LVol,RVol : Integer;
begin
  result := 0;
  WavPos  := GetOutputWavePos;   //ĐBuffer̈ʒu擾
  if (WavPos=-1)then exit;

  OggThreadLock;
  //pɂɎĝŃ[JŏێĂi
  BufSize := FWaveBufferSize;
  BufMem  := DWORD(FWaveBuffer.Memory);

  //KȒ̔g`Ƃ肾āAΒl̕ς߂Ă
  LVol  := 0;
  RVol  := 0;
  WavPos:= WavPos mod BufSize;
  for i:=0 to 255 do        //256
  begin
    SLR   := Pointer(BufMem + DWORD(WavPos));
    LVol  := LVol + abs(SLR.L);
    RVol  := RVol + abs(SLR.R);
    WavPos := WavPos + 4*2;
    if (WavPos>=BufSize)then WavPos := WavPos - BufSize;
  end;

  LVol := LVol div 256;
  RVol := RVol div 256;

  case c of
    0   : RESULT := LVol * (1/_AO_16BitVolumeMax);
    1   : RESULT := RVol * (1/_AO_16BitVolumeMax);
    else  RESULT := (LVol+RVol) * (1/_AO_16BitVolumeMax);
  end;

  OggThreadUnLock;
end;

//------------------------------------------------------------------------------
// O_ÖiMemoryjɏo͂
function TOggData.Rendering(TimeFix:Integer):Integer;
var
  len : Integer;
  ptr : PCHAR;
begin
  OggThreadLock;

  if ((FLoaded = FALSE)or(FPlayFlag=FALSE))then
  begin
    RESULT := 0;
    OggThreadUnLock;
    exit;
  end;

  len := FWaveBufferSize div 2;
  FPreWaveBufferPos := FWaveBufferPos;
  if (FWaveBufferPos = 0)then FWaveBufferPos := len
                         else FWaveBufferPos := 0;
  ptr := Offset;

  RESULT := RenderingToPointer(ptr,len,TimeFix,TRUE,FALSE);

  OggThreadUnLock;
end;

//------------------------------------------------------------------------------
// Waveg`ێp̈̃ԂԂ
function TOggData.Memory: Pointer;
begin
  result := FWaveBuffer.Memory;
end;

//------------------------------------------------------------------------------
// ŌRendering̊JnʒuԂ
function TOggData.Offset: Pointer;
begin
  result := Pointer(DWORD(FWaveBuffer.Memory) + FWaveBufferPos);
end;

//------------------------------------------------------------------------------
// [vwb_̓ǂݍ
{function TOggData.LoadLoop(ss: TMemoryStream): Boolean;
var
  hed : TAlphaOggHed;
  i   : Integer;
  pos : Int64;
  hc  : array[0..8] of char;
begin
  result := FALSE;
  if (ss = nil)then exit;
  if (ss.Size < Sizeof(TAlphaOggHed))then exit;

  //wb_F
  pos := ss.Position;
  ZeroMemory(@hc,9);
  ss.Read(hc,8);
  ss.Position := pos;
  if (hc <> 'ALPHAOGG')then exit;

  //wb_ǂݍ
  ss.Read(hed,Sizeof(TAlphaOggHed));
  for i:=0 to 15 do
    move(hed.Loop[i],LoopData[i],Sizeof(TOggLoop));
  result := TRUE;
end;             }

//------------------------------------------------------------------------------
// AlphaOggƂăt@Cɕۑ
{
function TOggData.SaveAlphaOgg(Filename: String): Boolean;
var
  fs : TFileStream;
  Hed: TAlphaOggHed;
  i  : Integer;
  Len: Integer;
  Ptr: PByte;
begin
  result := FALSE;
  if (FOggStream = nil)then exit;

  fs := TFileStream.Create(Filename,fmCreate);
  // wb_̏
  Hed.Hed := 'ALPHAOGG';
  for i:=0 to 15 do
    move(LoopData[i],Hed.Loop[i],sizeof(TOggLoop));
  fs.Write(Hed,Sizeof(TAlphaOggHed));
  //Oggt@C
  Len := FOggStream.Size - FOggOffset;
  Ptr := Pointer(DWORD(FOggStream.Memory)+FOggOffset);
  fs.Write(Ptr^,Len);
  fs.Free;

  result := TRUE;
end;
}

//------------------------------------------------------------------------------
// GtFNgiCRCUj
procedure TOggData.ApplyEQ(d: Pointer; Len: Integer);

  procedure SubApplyEQ(dd:Pointer; ll:Integer);
  var
    SLR,ALR : PLRWavePack16;
    lll     : Integer; //c
    wl      : Integer; //Waveǂݍޒ
    n       : Integer; //FFT̒
    n4      : Integer; //n/4
    iii     : Integer;
    dpos,tpos : Integer;
    EQValue : array[0..255] of Single;
  begin
    //TvOiFFT̊֌Wセɏ]j
    n := OGG_FFTSAMPLE;
    n4:= n div 4;
    //OGG_FFTSAMPLEɕăGtFNgĂ
    //  Ƃf[^FFTɓnAԊҌA̕Kp
    // ..O񃌃_O
    // ..Waveǂݍ݁Aۂɔf镔
    // ..WaveǂݍނAvZɂ邾Ŏۂɂ͔fȂ
    SLR := d;
    lll := ll div 4;       //ratePʂɕϊ
    while (lll > 0)do
    begin
      ALR := SLR;
      wl  := Min(lll,n4*3);          //̒
      dpos:= n4;                     //̊Jnʒu
      if (wl < n4*3)then tpos := dpos + wl - n4//Ɏg遡̊Jnʒu
                    else tpos := n4*2;
      // EQ̃tF[hݒ
      for iii:=0 to 255 do
      begin
        with FEQ[iii] do
        begin
          if (abs(sNow-sSet)<abs(sAdd*wl))then
          begin
            sNow := sSet;
            sAdd := 0.0;
          end
          else
          begin
            sNow := sNow + sAdd * wl;
          end;
          if (iii and 1 = 0)then EQValue[iii div 2]    := sNow
                            else EQValue[255-iii div 2]:= sNow;
        end;
      end;
      // Zbg
      for iii:=0 to n4 - 1 do
      begin
        FFT1.re[iii] := PreLWave[iii];
        FFT1.im[iii] := PreRWave[iii];
      end;
      // Zbg
      SLR := ALR;
      for iii:=0 to wl-1 do
      begin
        FFT1.re[iii+dpos] := SLR^.L;
        FFT1.im[iii+dpos] := SLR^.R;
        inc(SLR);
      end;
      // f钷(n4*2)𖞂ĂȂꍇ́A
      // mCY΍ƂďI܂œg`Ŗ߂
      dec(SLR);  //ŏIʒuɖ߂
      for iii:=wl to n4*3-1 do
      begin
        FFT1.re[iii+dpos] := SLR^.L;
        FFT1.im[iii+dpos] := SLR^.R;
      end;
      // PreWaveobt@Ɋi[
      for iii:=0 to n4 - 1 do
      begin
        PreLWave[iii] := FFT1.re[iii+tpos];
        PreRWave[iii] := FFT1.im[iii+tpos];
      end;
      // GtFNgKp
      FFT1.HammingWindow;   //n~O
      FFT1.FFT;             //g
      for iii:=0 to n - 1 do
      begin
        FFT1.re[iii]  := FFT1.re[iii] * EQValue[iii];
        FFT1.im[iii]  := FFT1.im[iii] * EQValue[iii];
      end;
      FFT1.UnFFT;           //tg
      FFT1.UnHammingWindow; //n~OɂČg`ɖ߂
      FFT1.SatSmallInt;     //Oa
      // ۂɔf(n4*2)𖞂Ă邩H
      if (wl < n4*3)then
      begin
        // ĂȂꍇ͑S
        SLR := ALR;
        for iii:=0 to wl-1 do
        begin
          SLR^.L := _Round(FFT1.re[iii+dpos]);
          SLR^.R := _Round(FFT1.im[iii+dpos]);
          inc(SLR);
        end;
        lll := lll - wl;     //c炷
      end
      else
      begin
        // Ă̂n4*2f
        SLR := ALR;
        for iii:=0 to n4*2 - 1 do
        begin
          SLR^.L := _Round(FFT1.re[iii+dpos]);
          SLR^.R := _Round(FFT1.im[iii+dpos]);
          inc(SLR);
        end;
        lll := lll - n4*2; //c炷
      end;

    end;
  end;

  procedure SubApplyNoiseCut(dd:Pointer; ll:Integer);
  var
    SLR : PLRWavePack16;
    i   : Integer;
  begin
    // gɒ[ɘMƁA傫ȍv`v`mCYꍇ
    // ̂ł
    SLR := d;
    for i:=0 to ll div 4 - 1 do
    begin
      if (abs(SLR^.L - PreNoiseLWave) > 25000)then
        SLR^.L := (Integer(SLR^.L) + PreNoiseLWave * 3) div 4;
      if (abs(SLR^.R - PreNoiseRWave) > 25000)then
        SLR^.R := (Integer(SLR^.R) + PreNoiseRWave * 3) div 4;

      PreNoiseLWave := SLR^.L;
      PreNoiseRWave := SLR^.R;
      inc(SLR);
    end;;
  end;
begin
  if (GetEQ)then SubApplyEQ(d,Len);
end;

//------------------------------------------------------------------------------
// gʂԂ
procedure TOggData.GetOutputGraph(d:PSingle);
var
  WavPos    : Integer;
  sPtr      : PSingle;
  BufMem    : DWORD;
  BufSize   : Integer;
  i         : Integer;
  t         : Single;
  SLR       : PLRWavePack32;
begin
  WavPos  := GetOutputWavePos;      //ĐBuffer̈ʒu擾
  if (WavPos=-1)then
  begin
    sPtr := d;
    for i:=0 to 255 do
    begin
      sPtr^ := 0.0;
      inc(sPtr);
    end;
    exit;
  end;

  OggThreadLock;

  //pɂɎĝŃ[JŏێĂi
  BufSize := FWaveBufferSize;
  BufMem  := DWORD(FWaveBuffer.Memory);

  //KȒ̔g`Ƃ肾āAΒl̕ς߂Ă
  WavPos:= WavPos mod BufSize;
  for i:=0 to 255 do        //256
  begin
    SLR   := Pointer(BufMem + DWORD(WavPos));
    FFT2.re[i] := SLR^.L;
    FFT2.im[i] := SLR^.R;
    WavPos := WavPos + 4*2;
    if (WavPos>=BufSize)then WavPos := WavPos - BufSize;
  end;

  FFT2.HammingWindow;
  FFT2.FFT;
  FFT2.NormalizeFFT;   //g̃m[}CY

  // gggƕ̂ŁAggɕёւďo
  // āASinC
  sPtr := d;
  for i:=0 to 127 do
  begin
    t := (abs(FFT2.re[i])+abs(FFT2.im[i]))*0.5;
    sPtr^ := t;
    inc(sPtr);
    t := (abs(FFT2.re[255-i])+abs(FFT2.im[255-i]))*0.5;
    sPtr^ := t;
    inc(sPtr);
  end;

  OggThreadUnLock;
end;

//------------------------------------------------------------------------------
// ݃A^CōĐĂWaveBuffer̈ʒuԂ
// WaveBuffer̐擪AhX牽BYTEڂ\̂łāAAhXł͂ȂB
// obt@ɂȂꍇ-1Ԃ
function TOggData.GetOutputWavePos: Integer;
var
  BufSize : Integer;
  TimePos : Single;
  WavPos  : Integer;
begin
  OggThreadLock;

  result := -1;
  //WaveBuffer̃TCY
  BufSize := FWaveBufferSize;
  //BYTEi񂾂Zo
  TimePos:= (TimeGetTime - FLastRendTime)*(1/1000);   // i񂾎ԂZo
  if (TimePos>(BufSize*(1/(44100*4*2))))or(TimePos<0)then
  begin
    OggThreadUnLock;
    exit;  // Đ^Cobt@傫ꍇ
  end;
  WavPos := _Round(TimePos*(44100*4*2));          // msWAVEʒuɕϊ
  WavPos := WavPos and $FFFFFFF8;                 // 8BYTEACgɍ킹
  if (WavPos >= BufSize)then
  begin
    OggThreadUnLock;
    exit;                 // WaveBufferɂȂꍇ
  end;
  //FWaveBuffer̃AhX߂
  if (FWaveBufferPos = 0)then WavPos := WavPos + BufSize div 2;
  WavPos := WavPos mod BufSize;
  RESULT := WavPos;

  OggThreadUnLock;
end;

//------------------------------------------------------------------------------
// ݂EQVolumeԂ
function TOggData.GetNowEQ(h: Integer): Single;
begin
  result := FEQ[h].sNow;
end;

//------------------------------------------------------------------------------
// ݂EQVolumeԂ
function TOggData.GetSetEQ(h: Integer): Single;
begin
  Result := FEQ[h].sSet;
end;

function TOggData.GetSetPan: Single;
begin
  RESULT := FPan.iNow / _AO_VOLUMEMUL;
end;

//------------------------------------------------------------------------------
// EQVolumeZbg
procedure TOggData.SetEQ(h: Integer; v: Single);
begin
  SetEQ(h,v,0.0);
end;

procedure TOggData.SetEQ(h: Integer; v, t: Single);
begin
  with FEQ[h] do
  if (t < 0.001)then
  begin
    sSet := v;
    sAdd := 0.0;
    sNow := v;
  end
  else
  begin
    sSet := v;
    sAdd := (sSet - sNow) / (t*44100);
  end;
end;

//------------------------------------------------------------------------------
// ȈՃCRCUݒ
procedure TOggData.SetEQ16(v1, v2, v3, v4, v5, v6, v7, v8, v9, v10, v11,
  v12, v13, v14, v15, v16, t: Single);
var
  yy : array[0..15] of Single;
  i     : Integer;
begin
  yy[00] := v1;
  yy[01] := v2;
  yy[02] := v3;
  yy[03] := v4;
  yy[04] := v5;
  yy[05] := v6;
  yy[06] := v7;
  yy[07] := v8;
  yy[08] := v9;
  yy[09] := v10;
  yy[10] := v11;
  yy[11] := v12;
  yy[12] := v13;
  yy[13] := v14;
  yy[14] := v15;
  yy[15] := v16;
  for i:=0 to 255 do SetEQ(i,Max(Harmite2(yy,i*15/255,16),0),t);
end;

procedure TOggData.SetEQ4(v1, v2, v3, v4, t: Single);
var
  yy : array[0..3] of Single;
  i     : Integer;
begin
  yy[00] := v1;
  yy[01] := v2;
  yy[02] := v3;
  yy[03] := v4;
  for i:=0 to 255 do SetEQ(i,Max(Harmite2(yy,i*3/255,4),0),t);
end;

procedure TOggData.SetEQ8(v1, v2, v3, v4, v5, v6, v7, v8, t: Single);
var
  yy : array[0..9] of Single;
  i     : Integer;
begin
  yy[00] := v1;
  yy[01] := v2;
  yy[02] := v3;
  yy[03] := v4;
  yy[04] := v5;
  yy[05] := v6;
  yy[06] := v7;
  yy[07] := v8;
  for i:=0 to 255 do SetEQ(i,Max(Harmite2(yy,i*7/255,8),0),t);
end;


function TOggData.harmite2(const x:array of Single; xx: Single; n: Integer): Single;
var
  n1,n2,n3,n4: Integer;
  t : Single;
begin
   n2 := trunc(xx);
   t  := Frac(xx);
   n1 := n2 - 1; if (n1 < 0  )then n1 := 0;
   n3 := n2 + 1; if (n3 > n-1)then n3 := n-1;
   n4 := n2 + 2; if (n4 > n-1)then n4 := n-1;
   result := Hermite(x[n1],x[n2],x[n3],x[n4], t);
end;


function TOggData.Hermite(p0, p1, p2, p3, aRate, tr1, tr2: Single): Single;
var
  InvRate: Single;
  RateDash: Single;
  p1Dash, p2Dash: Single;
begin
  // ⊮̕⏕
  InvRate:= 1.0 - aRate;
  RateDash:= aRate - 1.0;
  // GZڐ𓾂
  p1Dash:= ( p2 - p0 ) * tr1;
  p2Dash:= ( p3 - p1 ) * tr2;
  // Aj[Vpɂ͋}̂ŏɂ߂
  if ( p1 = p2 ) then begin
    p1Dash:= p1Dash * 0.25;
    p2Dash:= p2Dash * 0.25;
  end;
  // vZ
  Result:=
    p1 *     ( RateDash * RateDash ) * ( aRate * 2.0 + 1.0 ) +
    p2 *     ( aRate * aRate ) *       ( 3.0 - aRate * 2.0 ) +
    p1Dash * ( InvRate * InvRate ) *   ( aRate ) +
    p2Dash * ( RateDash ) *            ( aRate * aRate );
end;

function TOggData.GetNowPan: Single;
begin
  OggThreadLock;
  RESULT := FPan.iNow / _AO_VOLUMEMUL;
  OggThreadUnLock;
end;

function TOggData.GetPlayState(Lock:Boolean): TPLAYSTATE;
begin
  if (Lock)then OggThreadLock;

  if not(FLoaded)then
  begin
    RESULT := psNONE;
    if (Lock)then OggThreadUnLock;
    exit;
  end;

  RESULT := psSTOP;

  if (FPlayFlag)then
    if (FLoopFlag)then RESULT := psLOOP
                  else RESULT := psPLAY;

  if (Lock)then OggThreadUnLock;
end;

procedure TOggData.Pause(Lock:Boolean);
begin
  if (Lock)then OggThreadLock;
  FPlayFlag := FALSE;
  FLoopFlag := FALSE;
  if (Lock)then OggThreadUnLock;

  //FPreTimeTell := 0;
  //ZeroMemory(FWaveBuffer.Memory,FWaveBufferSize);
end;

//------------------------------------------------------------------------------
//ۃXs[J痬Ă鉹̍ĐԈʒuԂ
function TOggData.GetOutputTime: Single;
var
  t,a,b : Single;
begin
  OggThreadLock;
  
  if (FLastRendOggTime=0.0)then
  begin
    RESULT := 0.0;
    OggThreadUnLock;
    exit;
  end;
  a := FWaveBufferSize * (1/(44100*4*2));              //BufferSize̎
  t := (TimeGetTime - FLastRendTime) * (1/1000);
  if (t>a)then t := a;
  t := a*0.5-t;
  t := FLastRendOggTime - t;

  //Ԃ͈̔͒
  if (t > TotalTime)then t := TotalTime;
  b := TimeTell(FALSE);
  if (t>b)then t := b;
  if (t<b-a)then t := b-a;

  //덷ŋt߂肵ꍇ̑Ώ
  if (t<FPreOutputTime)then
    if (FPreOutputTime-t<a)then t:=FPreOutputTime;

  FPreOutputTime := t;
  Result := t;

  OggThreadUnLock;
end;

//------------------------------------------------------------------------------
//Seek\ǂH
function TOggData.SeekAble: Boolean;
begin
  RESULT := FALSE;
  if (FLoaded = FALSE)then exit;
  if (_VorbisfileDll.wu_ov_seekable(FOggVorbisFile) <> 0)then RESULT := TRUE;
end;

function TOggData.GetEQ: Boolean;
var
  i : Integer;
  b : Boolean;
begin
  b := FALSE;
  for i:=0 to 255 do
    if (abs(GetNowEQ(i)-1.0)+abs(GetSetEQ(i)-1.0) > 0.01)then b := TRUE;
  RESULT := b;
end;

procedure TOggData.SetMasterVolume(v: Single);
begin
  OggThreadLock;
  FMasterVolume := _Round(v*256);
  OggThreadUnLock;
end;

procedure TOggData.SetPan(v, t: Single);
var
  vv : Single;
begin
  OggThreadLock;

  vv := v;
  if (vv < -1.0)then vv := -1.0;
  if (vv >  1.0)then vv := 1.0;

  with FPan do
  begin
    if (t < 0.01)then
    begin
      iSet := Trunc(_AO_VOLUMEMUL*vv);
      iNow := iSet;
      iAdd := 0;
    end
    else
    begin
      iSet := Trunc(_AO_VOLUMEMUL*vv);
      iAdd := Trunc((iSet-iNow)/(t*44100));
    end;
  end;

  OggThreadUnLock;
end;

function TOggData.GetMasterVolume: Single;
begin
  OggThreadLock;
  RESULT := FMasterVolume / 256;
  OggThreadUnLock;
end;

function TOggData.GetChannelVolume: Single;
begin
  OggThreadLock;
  RESULT := FChannelVolume / 256;
  OggThreadUnLock;
end;

procedure TOggData.SetChannelVolume(v: Single);
begin
  OggThreadLock;
  FChannelVolume := _Round(v*256);
  OggThreadUnLock;
end;

procedure TOggData.WhiteSkip(v: Integer);
var
  buf : array[0..255] of SmallInt;
  Sum : Integer;
  Len,Len2 : Integer;
  i : Integer;
  t : Single;
begin
  if not(FLoaded)then exit;

  OggThreadLock;

  t := TimeTell;
  while(t < TotalTime)do
  begin
    //l𑪒
    Len := 256;
    while(Len>0)do
    begin
      Len2 := RenderingToPointerOgg(@buf[0],Len);
      if (len2 < 1)then break;
      Len := Len - Len2;
    end;
    Sum := 0;
    for i:=0 to 255 do
      Sum := Sum + abs(buf[i]);
    Sum := Sum div 256;
    if (Sum > v)then break;
    //i܂
    t := t + _WHITESKIPTIME;
    TimeSeek(t,FALSE);
  end;

  if (t>TotalTime-_WHITESKIPTIME)then t := 0.0;
  t := t - _WHITESKIPTIME;
  if (t<0)then t := 0.0;
  TimeSeek(t,FALSE);

  OggThreadUnLock;
end;

function TOggData.OggReadWaveFormat(dptr:Pointer; ReadLen:Integer):Integer;
var
  i,n   : Integer;
  wdptr : ^SmallInt;
  RLen  : Integer;
  current_section : Integer;
begin
  RESULT := -1;
  //_O钷𒲐iŏII44100Hz2ch̕ῗݏoȂpɁj
  RLen := ReadLen;
  //tH[}bgɂď𕦂
  case (OggRate*10+OggChannels) of
    441002:  //44100Hz 2Channel
      begin
        //ϊ
        RLen := _VorbisfileDll.wu_ov_read(FOggVorbisFile,dptr,RLen,0,2,1,current_section);
        RESULT := RLen;
      end;
    441001:  //44100Hz 1Channel
      begin
        //ŏII44100Hz2Chɕῗ݂Ȃ悤 /2 
        RLen := RLen div 2;
        //_O
        RLen := _VorbisfileDll.wu_ov_read(FOggVorbisFile,@FTempFormatBuf[0],RLen,0,2,1,current_section);
        //ϊ
        wdptr := dptr;
        n := RLen div 2-1;
        for i:=0 to n do
        begin
          wdptr^ := FTempFormatBuf[i]; inc(wdptr);
          wdptr^ := FTempFormatBuf[i]; inc(wdptr);
        end;
        RESULT := RLen * 2;
      end;
    221002:
      begin
        RLen := RLen div 2;
        //_O
        RLen := _VorbisfileDll.wu_ov_read(FOggVorbisFile,@FTempFormatBuf[0],RLen,0,2,1,current_section);
        //ϊ
        wdptr := dptr;
        n := RLen div (2*2) - 1;
        for i:=0 to n do
        begin
          wdptr^ := FTempFormatBuf[i*2];   inc(wdptr);
          wdptr^ := FTempFormatBuf[i*2+1]; inc(wdptr);
          wdptr^ := FTempFormatBuf[i*2];   inc(wdptr);
          wdptr^ := FTempFormatBuf[i*2+1]; inc(wdptr);
        end;
        RESULT := RLen * 2;
      end;
    221001:
      begin
        RLen := RLen div 4;
        //_O
        RLen := _VorbisfileDll.wu_ov_read(FOggVorbisFile,@FTempFormatBuf[0],RLen,0,2,1,current_section);
        //ϊ
        wdptr := dptr;
        n := RLen div 2 - 1;
        for i:=0 to n do
        begin
          wdptr^ := FTempFormatBuf[i]; inc(wdptr);
          wdptr^ := FTempFormatBuf[i]; inc(wdptr);
          wdptr^ := FTempFormatBuf[i]; inc(wdptr);
          wdptr^ := FTempFormatBuf[i]; inc(wdptr);
        end;
        RESULT := RLen * 4;
      end;
  end;
end;

function TOggData.RenderingToPointerOgg(ptr:Pointer; len16:Integer):Integer;
var
  ptr2 : PCHAR;
  LeftLen,ret : Integer;
begin
  //WaveɓWJ
  //w肵_OĕԂĂȂ
  //̂ŁAxRead݂āAɕă_OĂKvB
  //2048BYTE炢xɃ_O悤B
  ptr2    := ptr;
  LeftLen := len16;
  while (LeftLen > 0)do
  begin
    //_O
    ret := OggReadWaveFormat(ptr2,LeftLen);
    //\ʃG[
    if (ret < 0)then
    begin
      result := ret;
      Pause(FALSE);
      exit;
    end;
    //I[m
    if (ret = 0)then
      if (FLoopFlag)then
      begin
        //[vĐ
        _VorbisfileDll.wu_ov_time_seek(FOggVorbisFile,_SEEKZERO);
        FPreOutputTime := 0;
      end
      else
      begin
        //~A
        Pause(FALSE);
        _VorbisfileDll.wu_ov_time_seek(FOggVorbisFile,_SEEKZERO);
        FPreOutputTime := 0;
        //ZeroMemory(ptr2,LeftLen);
        result := len16 - LeftLen;
        exit;
      end;
    //_Oi܂B
    inc(ptr2,ret);
    dec(LeftLen,ret);
  end;

  result := len16 - LeftLen;
end;

function TOggData.GetNowPlayState(Lock:Boolean): TPLAYSTATE;
begin
  if (Lock)then OggThreadLock;

  if (FPlayFlag)then
    RESULT := GetPlayState(FALSE)
  else
    RESULT := FPrePlayState;

  if (Lock)then OggThreadUnLock;

  {if not(FLoaded)then
  begin
    RESULT := psNONE;
    exit;
  end;

  RESULT := psStop;

  //FPreTellTime ɂނčĐȂ̂ŁÂ݂Ɣr
  if (FPlayFlag=FALSE)then
    if (abs(GetOutputTime-FPreTimeTell)>0.01)then
    begin
      if (FLoopFlag)then RESULT := psLOOP
                    else RESULT := psPLAY;
    end;

  if (FPlayFlag)then
    if (FLoopFlag)then RESULT := psLOOP
                  else RESULT := psPLAY;   }
end;

procedure TOggData.OggThreadLock;
begin
  FSemaphore.Lock;
end;

procedure TOggData.OggThreadUnLock;
begin
  FSemaphore.UnLock;
end;

function TOggData.LoadOgg2(ss: TStream): Boolean;
var
  ms : TMemoryStream;
begin
  ms := TmemoryStream.Create;
  ss.Position := 0;
  ms.LoadFromStream(ss);
  ms.Position := 0;
  RESULT := LoadOgg(ms);   //΂
end;

function TOggData.GetUseMemorySize: Integer;
var
  s : Integer;
begin
  s := 0;
  if (FOggStream<>nil)then s := s + FOggStream.Size;
  if (FWaveBuffer<>nil)then s := s + FWaveBufferSize;
  RESULT := s;
end;


procedure TOggData.GetLoopInfo;
var
  i : Integer;
  sl,sl2 : TStringList;
  n,c : Integer;
  b,e : Single;
begin
  if (FOggStream=nil)then exit;

  sl2 := GetComment('COMMENT');
  for i:=0 to sl2.Count-1 do
  begin
    sl := _DivideText(',',AnsiLowerCase(sl2.Strings[i]),TRUE,TRUE,5);
    if (sl.Strings[0]='*looptime')then
    begin
      n := StrToIntDef(sl.Strings[1],0);
      b := StrToFloatDef(sl.Strings[2],0.0);
      e := StrToFloatDef(sl.Strings[3],0.0);
      c := StrToIntDef(sl.Strings[4],-1);
      if (n>=0)or(n<16)then
      begin
        LoopData[n].Count := c;
        LoopData[n].BeginTime := b;
        LoopData[n].EndTime := e;
      end;
    end;
    if (sl.Strings[0]='*loopsample')then
    begin
      n := StrToIntDef(sl.Strings[1],0);
      b := StrToFloatDef(sl.Strings[2],0.0);
      e := StrToFloatDef(sl.Strings[3],0.0);
      c := StrToIntDef(sl.Strings[4],-1);
      if (n>=0)or(n<16)then
      begin
        LoopData[n].Count := c;
        LoopData[n].BeginTime := b/OggRate;
        LoopData[n].EndTime := e/OggRate;
      end;
    end;
    sl.Free;
  end;
  sl2.Free;
  
end;

function TOggData._DivideText(const t, s: String; SpaceCut,
  CommentCut: Boolean; n: Integer): TStringList;
  //QoCgLN^[R[hǂ̃`FbN
  function If2ByteChar(c : Char):Boolean;
  begin
    if ( ( (c > char($80))and(c < char($A0)) ) or
         ( (c > char($DF))and(c <=char($FF)) ) )then
      result := TRUE
    else
      result := FALSE;
  end;
var
  i,l : Integer;
  sl: TStringList;
  ss,aa: String;
begin
  ss := '';
  aa := '';
  i  := 0;
  l  := Length(s);
  sl := TStringList.Create;
  while (i<l) do
  begin
    if (If2ByteChar(s[i+1]))then
    begin
      aa := s[i+1] + s[i+2];
      inc(i,2);
    end
    else
    begin
      aa := s[i+1];
      inc(i);
    end;
    ///TAB
    if (SpaceCut)then
    begin
      if (aa = ' ')then continue;
      if (aa = char($09))then continue;
    end;
    //RgAEgo
    if (CommentCut)then
      if (aa = '/')then
        if (i<l)then
          if (s[i+1] = '/')then break;
    //؂
    if (aa = t)then
    begin
      sl.Add(ss);
      ss := '';
      continue;
    end;
    //ǋL
    ss := ss + aa;
  end;
  if (ss<>'')then sl.Add(ss);
  if (aa=t)then sl.Add('');

  for i:=sl.Count to n-1 do
    sl.Add('');

  RESULT := sl;
end;

function TOggData.GetComment(name: String): TStringList;
var
  s,ss : String;
  i,l : Integer;
  c : char;
  sl : TStringList;
begin
  s := OggUserComment.Values[name];

  sl := TStringList.Create;
  i := 0;
  l := Length(s);
  while (i<l)do
  begin
    c := s[i+1];
    if (c=char($0D))then
      if (i<l-2)then
        if (s[i+2]=char($0A))then
        begin
          sl.Add(ss);
          ss := '';
          inc(i,2);
          continue;
        end;
    ss := ss + c;
    inc(i);
  end;
  if (ss<>'')then sl.Add(ss);

  RESULT := sl;
end;

procedure TOggData.SetAGC(Gain, Rate: Single; Target, Quiet: Integer);
begin
  AGC1.AmpGain := Gain;
  AGC1.AmpRate := rate;
  AGC1.AmpTarget := Target;
  AGC1.AmpQuiet := Quiet;
  AGC1.Refresh;
end;

procedure TOggData.SetAGC(Vol: Single);
var
  a : Integer;
begin
  a := _Round(30000 * vol);
  SetAGC(1.0,0.05,a,800);
end;

function TOggData.PreOffset: Pointer;
begin
  result := Pointer(DWORD(FWaveBuffer.Memory) + FPreWaveBufferPos);
end;

function TOggData._Round(x: Single): Integer;
begin
  if (x<0.0)then RESULT := trunc(x-0.5)
            else RESULT := trunc(x+0.5);   
end;

{ TSemaphore }

constructor TALOGGSemaphore.Create(name:String; n: Integer);
begin
  if (name='')then
    FSema := CreateSemaphore(nil,n,n,nil)           //O
  else
    FSema := CreateSemaphore(nil,n,n,PChar(name));  //OL
end;

destructor TALOGGSemaphore.Destroy;
begin
  CloseHandle(FSema);
  FSema := 0;
  inherited;
end;

procedure TALOGGSemaphore.Lock;
begin
  WaitForSingleObject(FSema,INFINITE);
end;

procedure TALOGGSemaphore.UnLock;
var
  p : Integer;
begin
  ReleaseSemaphore(FSema,1,@p);
end;

end.
