//
//      OggVorbis Player Library iKvȂ̂ˁj
//      Coder : Ko-Ta



unit OggPlayerLib;

interface

uses Windows, SysUtils, Classes, OggDataLib, FFTLib, mmSystem;

//==============================================================================
//Ogg Player Class
//      Đɂ͂̃NXgƕ֗Ȃ
type
  TWavePositionEvent = procedure(var pos:Integer; var len:Integer) of Object;
  TOggPlayerStreamEvent = procedure (ofs:Pointer; SampleLen:Integer) of Object;
type TOggPlayer = class
  private
  protected
    FSemaphore : TALOGGSemaphore;
    FOutputVolume : Integer;
    FLastRendTime  : Int64;
    FWaveBuffer    : TMemoryStream;
    FWaveBufferSize : Integer;
    FTempBuffer    : array of Integer;
    FTempBufferSize : Integer;
    FWaveBufferPos,FPreWaveBufferPos : DWORD;
    FWavePositionEvent:TWavePositionEvent;
    FHDRMaxVolume : Integer;  //ő压͈
    FHDRMinVolume : Integer;  //ŏ͈
    FHDRVolume  : Integer;    //݂͈̎
    FHDRDownVolume : Integer; //{[l(*256)
    FHDRDelaySample: Integer; //xTv
    FHDRDelayCount : Integer; //xJE^
    FWaveMaxVolume : Integer;

    FStreamEvent:TOggPlayerStreamEvent;

    procedure   ThreadLock;
    procedure   ThreadUnLock;
    function    GetHDRVolume:Integer;
    function    RenderingToPointer(d:Pointer; Len16:Integer; Lock:Boolean):Integer;
  public
    OggData   : array of TOggData;
    FFT2      : TFFT;
    MaxChannel: Integer;

    destructor  Destroy; override;
    constructor Create(Len16:Integer; MaxCh:Integer=8);
    //ǂݍ
    procedure   Load(ch:Integer; o:TOggdata; Lock:Boolean=TRUE);
    procedure   UnLoad(ch:Integer; Lock:Boolean=TRUE);
    //_O
    procedure   Rendering;
    //
    procedure   Init;
    //ĐE~
    procedure   Play(Loop:Boolean); overload;
    procedure   Play(ch:Integer;Loop:Boolean); overload;
    procedure   Stop(ch:Integer); overload;
    procedure   Stop; overload;
    procedure   Pause(ch:Integer);
    procedure   Swap(ch1,ch2:Integer);
    procedure   WhiteSkip(ch,v:Integer);
    procedure   SetHDRArea; overload;
    procedure   SetHDRArea(vMin,vMax,vDown:Integer; DelaySample:Integer=44100; Volume:Integer=-1); overload;
    //ʒ
    procedure   SetOutputVolume(v:Single);
    procedure   SetMasterVolume(v:Single); overload;      //Ŝ̉ʐݒ
    procedure   SetMasterVolume(ch : Integer; v:Single); overload;
    function    GetMasterVolume(ch:Integer):Single;
    procedure   SetChannelVolume(ch:Integer;v:Single);    //eOgg`l̉ʐݒ
    function    GetChannelVolume(ch:Integer):Single;
    procedure   SetVolume(ch:Integer; v:Single=1.0; t:Single=0.0);
    procedure   SetPan(ch:Integer; v:Single=0.0; t:Single=0.0);
    function    GetNowVolume(ch:Integer):Single;
    function    GetSetVolume(ch:Integer):Single;
    function    GetNowPan(ch:Integer):Single;
    function    GetSetPan(ch:Integer):Single;
    //
    procedure   TimeSeek(ch:Integer; t:Single);
    function    TimeTell(ch:Integer):Single;
    function    TotalTime(ch:Integer):Single;
    //[v
    function    GetLoopCount(ch,n:Integer):Integer;
    procedure   SetLoopCount(ch,n,l:Integer);
    //A^CWaveVolume擾i덷j
    function    GetOutputWavePos(ch:Integer):Integer;
    function    GetOutputSum(ch:Integer):Single; overload;
    function    GetOutputSum(ch,c:Integer):Single; overload;
    procedure   GetOutputGraph(ch:Integer; d:PSingle);
    function    GetOutputTime(ch:Integer):Single;
    function    GetMasterOutputWavePos:Integer;
    function    GetMasterOutputSum:Single; overload;
    function    GetMasterOutputSum(c:Integer):Single; overload;
    procedure   GetMasterOutputGraph(d:PSingle);
    //EQ
    procedure   SetEQ(ch:Integer; h:Integer; v:Single); overload;
    procedure   SetEQ(ch:Integer; h:Integer; v,t:Single); overload;
    function    GetNowEQ(ch:Integer; h:Integer):Single;
    function    GetSetEQ(ch:Integer; h:Integer):Single;
    function    GetEQ(ch:Integer):Boolean;
    procedure   SetEQ16(ch:Integer; v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,v13,v14,v15,v16, t : Single);
    procedure   SetEQ8(ch:Integer; v1,v2,v3,v4,v5,v6,v7,v8, t:Single);
    procedure   SetEQ4(ch:Integer; v1,v2,v3,v4, t:Single);
    //ԃtO
    function    GetPlayState(ch:Integer) : TPLAYSTATE;
    function    GetNowPlayState(ch:Integer) : TPLAYSTATE;
    //
    function    Memory  : Pointer;  //Waveg`i[|C^
    function    Offset  : Pointer;  //_OWaveg`̐擪AhX
    function    PreOffset : pointer;
    //
    property    WavePositionEvent:TWavePositionEvent read FWavePositionEvent write FWavePositionEvent;
    property    StreamEvent:TOggPlayerStreamEvent read FStreamEvent write FStreamEvent;
    property    HDRVolume:Integer read GetHDRVolume;
    property    HDRMaxVolume:Integer read FHDRMaxVolume;
    property    HDRMinVolume:Integer read FHDRMinVolume;
    property    HDRDownVolume:Integer read FHDRDownVolume;
    property    HDRDelaySample:Integer read FHDRDelaySample;
    property    WaveMaxVolume:Integer read FWaveMaxVolume;
end;

implementation

const
  _AO_FADEMUL = 256;

//==============================================================================
{ TOggPlayer }
//------------------------------------------------------------------------------

constructor TOggPlayer.Create(Len16:Integer; MaxCh:Integer);
begin
  FSemaphore := TALOGGSemaphore.Create('');
  FStreamEvent := nil;
  
  //gp`lf[^ݒ肷
  MaxChannel := MaxCh;
  SetLength(OggData,MaxChannel);

  //WAVEg`obt@(16bit)
  FWaveBuffer := TmemoryStream.Create;
  FWaveBuffer.SetSize(Len16);
  FWaveBufferSize := FWaveBuffer.Size;
  //vZpobt@(32bit)
  SetLength(FTempBuffer,Len16 div 2);
  FTempBufferSize := (Len16 div 2)*4; //32Bit=4Byte

  //ꂢꂢ
  Init;

  //t[GCϊ FFTNX̐
  FFT2 := TFFT.Create(256);
end;

//------------------------------------------------------------------------------
// j
destructor TOggPlayer.Destroy;
begin
  //ꂢꂢ
  Init;
  FStreamEvent := nil;

  //Waveg`obt@̉
  FWaveBuffer.Free;

  //FFTNX
  FFT2.Free;

  FSemaphore.Free;
  inherited;
end;

//------------------------------------------------------------------------------
// e`l̏o͉ʐݒ擾
function TOggPlayer.GetChannelVolume(ch: Integer): Single;
begin
  result := 1.0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].GetChannelVolume;
end;

//------------------------------------------------------------------------------
// Ogǧ݂̉ʂԂ
function TOggPlayer.GetNowVolume(ch: Integer): Single;
begin
  result := 1.0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].GetNowVolume;
end;

//------------------------------------------------------------------------------
// Ogg̐ݒ艹ʂԂ
function TOggPlayer.GetSetVolume(ch: Integer): Single;
begin
  result := 1.0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].GetSetVolume;
end;

//------------------------------------------------------------------------------
// S`li鉹ʐݒ擾
function TOggPlayer.GetMasterVolume(ch:Integer): Single;
begin
  result := 0.0;
  if (OggData[ch] = nil)then exit;

  result := OggData[ch].GetMasterVolume;
end;

//------------------------------------------------------------------------------
// 
procedure TOggPlayer.Init;
var
  i : Integer;
begin
  ThreadLock;

  //Volume
  for i:=0 to MaxChannel-1 do
    OggData[i] := nil;
  FOutputVolume := 256;
  ZeroMemory(FWaveBuffer.Memory,FWaveBufferSize);

  ThreadUnLock;

  SetHDRArea;
  SetMasterVolume(1.0);
end;

//------------------------------------------------------------------------------
// e`l̉ʂݒ
procedure TOggPlayer.SetChannelVolume(ch: Integer; v: Single);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].SetChannelVolume(v);
end;

//------------------------------------------------------------------------------
// S`li鉹ʐݒ
procedure TOggPlayer.SetMasterVolume(v: Single);
var
  i : Integer;
begin
  for i:=0 to MaxChannel-1 do
    if (OggData[i] <> nil)then
      OggData[i].SetMasterVolume(v);
end;

//------------------------------------------------------------------------------
// Ogg̉ʂݒ
procedure TOggPlayer.SetVolume(ch: Integer; v, t: Single);
begin
  if (OggData[ch] = nil)then exit;

  OggData[ch].SetVolume(v,t);
end;

//------------------------------------------------------------------------------
// w^CɃV[N
procedure TOggPlayer.ThreadLock;
begin
  FSemaphore.Lock;
end;

procedure TOggPlayer.ThreadUnLock;
begin
  FSemaphore.UnLock;
end;

procedure TOggPlayer.TimeSeek(ch:Integer; t: Single);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].TimeSeek(t);
end;

//------------------------------------------------------------------------------
// ݂̈ʒuiĐoߎԁjԂ
function TOggPlayer.TimeTell(ch:Integer): Single;
begin
  result := 0.0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].TimeTell;
end;

//------------------------------------------------------------------------------
// Ȃ̒Ԃ
function TOggPlayer.TotalTime(ch: Integer): Single;
begin
  result := 0.0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].TotalTime;
end;

//------------------------------------------------------------------------------
// Đ̗L
function TOggPlayer.GetPlayState(ch: Integer): TPLAYSTATE;
begin
  result := psNONE;
  if (OggData[ch] = nil)then exit;

  result := OggData[ch].GetPlayState;
end;

//------------------------------------------------------------------------------
// [vJEg̎擾
function TOggPlayer.GetHDRVolume: Integer;
begin
  RESULT := FHDRVolume div _AO_FADEMUL;
end;

function TOggPlayer.GetLoopCount(ch, n: Integer): Integer;
begin
  result := 0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].GetLoopCount(n);
end;

//------------------------------------------------------------------------------
// [vJEg̐ݒ
procedure TOggPlayer.SetHDRArea;
begin
  SetHDRArea(_AO_16BitVolumeMax,_AO_16BitVolumeMax*2,500,44100,-1);
end;

procedure TOggPlayer.SetHDRArea(vMin,vMax,vDown,DelaySample:Integer; Volume:Integer);
begin
  ThreadLock;

  if (vMax<vMin)then vMax := vMin;
  if (vMin>vMax)then vMin := vMax;
  if (vDown<1)then vDown := 1;
  if (DelaySample<1)then DelaySample := 1;

  FHDRMaxVolume := vMax;
  FHDRMinVolume := vMin;
  FHDRDownVolume := vDown;
  FHDRDelaySample:= DelaySample;
  FWaveMaxVolume := 0;

  if not(Volume=-1)then
  begin
    FHDRVolume := Volume*_AO_FadeMUL;
    if (FHDRVolume<FHDRMinVolume*_AO_FadeMUL)then FHDRVolume := FHDRMinVolume*_AO_FadeMUL;
    FHDRDelayCount := 0;
  end;

  ThreadUnLock;
end;

procedure TOggPlayer.SetLoopCount(ch, n, l: Integer);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].SetLoopCount(n,l);
end;

//------------------------------------------------------------------------------
// A^CWAVEg`̍vlO`P͈̔͂ŕԂ
function TOggPlayer.GetOutputSum(ch, c: Integer): Single;
begin
  result := 0.0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].GetOutputSum(c);
end;

function TOggPlayer.GetOutputSum(ch: Integer): Single;
begin
  result := GetOutputSum(ch,2);
end;

//------------------------------------------------------------------------------
// Đ
procedure TOggPlayer.Play(ch: Integer; Loop: Boolean);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].Play(Loop);
end;

procedure TOggPlayer.Play(Loop: Boolean);
var
  i : Integer;
begin
  for i:=0 to MaxChannel-1 do
    Play(i,Loop);
end;

//------------------------------------------------------------------------------
//~
procedure TOggPlayer.Stop;
var
  i : Integer;
begin
  for i:=0 to MaxChannel-1 do Stop(i);
end;

procedure TOggPlayer.Stop(ch: Integer);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].Stop;
end;

//------------------------------------------------------------------------------
// OggData̓o^
procedure TOggPlayer.Load(ch: Integer; o: TOggdata; Lock:Boolean);
var
  i : Integer;
begin
  if (Lock)then ThreadLock;
  
  // o^imhkj
  if (o = nil)then
  begin
    OggData[ch] := nil;
    if (Lock)then ThreadUnLock;
    exit;
  end;

  //d΍
  for i:=0 to MaxChannel-1 do
    if (DWORD(OggData[i]) = DWORD(o))then UnLoad(i,FALSE);

  //o^
  OggData[ch] := o;

  if (Lock)then ThreadUnLock;
end;

//------------------------------------------------------------------------------
// vg`_O
function TOggPlayer.RenderingToPointer(d:Pointer; Len16:Integer; Lock:Boolean):Integer;
  const _HDRLength = 32;
  procedure _HDRFuncSub(idx,sample:Integer);
  var
    sLR : PLRWavePack32;
    vMax,ll,rr,nn : Integer;
    i,v : Integer;
  begin
    nn := FHDRDelaySample div _HDRLength;  //VolumeDownDelayTime
    if (FHDRMaxVolume=FHDRMinVolume)then
    begin
      //ꍇ
      FHDRVolume := FHDRMinVolume*_AO_FADEMUL;
    end
    else
    begin
      //őg`Uꕝ擾
      vMax := 0;
      sLR := @FTempBuffer[idx*2];
      for i:=0 to sample-1 do
      begin
        ll := sLR.L;
        rr := sLR.R;
        if (ll<0)then ll := -ll;
        if (rr<0)then rr := -rr;
        if (ll>vMax)then vMax := ll;
        if (rr>vMax)then vMax := rr;
        inc(sLR);
      end;
      //
      if (FWaveMaxVolume<vMax)then FWaveMaxVolume := vMax;
      //͈͂̕ύX
      v := FHDRVolume div _AO_FADEMUL;
      if (vMax>v)then
      begin
        FHDRVolume := (FHDRVolume + vMax*256*3) div 4;
        FHDRDelayCount := 0;
      end;
      if (vMax<v)then
      begin
        if (FHDRDelayCount>nn)then
          FHDRVolume := FHDRVolume-FHDRDownVolume
        else
          inc(FHDRDelayCount);
      end;

      if (FHDRVolume>FHDRMaxVolume*_AO_FADEMUL)then FHDRVolume := FHDRMaxVolume*_AO_FADEMUL;
      if (FHDRVolume<FHDRMinVolume*_AO_FADEMUL)then FHDRVolume := FHDRMinVolume*_AO_FADEMUL;
    end;
    
    //16Bit̍őlȂϊKvȂ
    if (FHDRVolume=_AO_16BitVolumeMax*_AO_FADEMUL)then exit;  
    //{[l߂(0`256`)
    //idiv 256 ̓I[o[t[΍j
    if (FHDRVolume<65536)then FHDRVolume := 65536;
    v := (_AO_16BitVolumeMax*256) div (FHDRVolume div _AO_FADEMUL);
    //g`ɔf
    sLR := @FTempBuffer[idx*2];
    for i:=0 to sample-1 do
    begin
      sLR.L := sLR.L * v div 256;
      sLR.R := sLR.R * v div 256;
      inc(sLR);
    end;
  end;
  procedure _HDRFunc(sample:Integer);
  var
    n,l,a : Integer;
  begin
    l := sample;
    n := 0;
    while (n<l)do
    begin
      a := l-n;
      if (a>_HDRLength)then a := _HDRLength ;
      _HDRFuncSub(n,a);    //_HDRLengthƂɕď
      n := n + a;
    end;
  end;
var
  SLR  : array[0..31] of PLRWavePack32;
  TLR  : PLRWavePack32;
  DLR  : PLRWavePack16;
  Count,aa1,aa2,TimeFix : integer;
  i,j,n  : Integer;
  RVol,LVol : Integer;
begin
  if (Lock)then ThreadLock;

  FWaveMaxVolume := FWaveMaxVolume*7 div 8;

  //_OJnꂽԂ擾
  TimeFix := 0;
  FLastRendTime := TimeGetTime;
  if (Assigned(FWavePositionEvent))then
  begin
    //傤ǋ؂Ԃʉ߂Ԃ
    FWavePositionEvent(aa1,aa2);
    if (aa2>0)then
    begin
      aa1 := aa1 mod (aa2 div 2);
      TimeFix := Round(aa1*((1/176400)*1000));  //덷msPʂɕϊ
      FLastRendTime := FLastRendTime - TimeFix;
    end;
  end;

  //Đ̂̂𒲂ׁA32Bit_O
  Count := 0;
  for i:=0 to MaxChannel-1 do
    if (OggData[i] <> nil)then
      if (OggData[i].Rendering(TimeFix) > 0)then
      begin
        SLR[Count] := OggData[i].Offset;
        inc(Count);
      end;

  //_OTv
  n := (Len16 div (2*2));                        //Sample Count       16Bit2Ch=4Byte

  //g`f[^̏W
  aa1 := n*2*4;
  if (aa1>FTempBufferSize)then aa1 := FTempBufferSize;
  ZeroMemory(@FTempBuffer[0],aa1);   //32BitBufferClear   32Bit=4Byte
  for i:=0 to Count-1 do
  begin
    TLR := @FTempBuffer[0];
    for j:=0 to n-1 do
    begin
      TLR.L := TLR.L + SLR[i].L;
      TLR.R := TLR.R + SLR[i].R;
      inc(TLR);
      inc(SLR[i]);
    end;
  end;

  //StreamEvent
  //Op
  if Assigned(FStreamEvent)then FStreamEvent(@FTempBuffer[0],n);

  //ώ͈͌vZ
  _HDRFunc(n);

  //16BitWaveobt@Ɋۂߍ
  DLR := d;
  TLR := @FTempBuffer[0];
  for i:=0 to n-1 do
  begin
    LVol := TLR.L;
    RVol := TLR.R;
    //OutputVolume
    LVol := LVol * FOutputVolume div 256;
    RVol := RVol * FOutputVolume div 256;
    //OverFlow
    if (LVol > +32767)then LVol := +32767;
    if (LVol < -32767)then LVol := -32767;
    if (RVol > +32767)then RVol := +32767;
    if (RVol < -32767)then RVol := -32767;
    //Write
    DLR.L := SmallInt(LVol);
    DLR.R := SmallInt(RVol);
    inc(TLR);
    inc(DLR);
  end;

  //_OԂ
  result := len16;

  if (Lock)then ThreadUnLock;
end;

//------------------------------------------------------------------------------
// f[^A[hinilԂނj
procedure TOggPlayer.UnLoad(ch: Integer; Lock:Boolean);
begin
  Load(ch,nil,Lock);
end;

//------------------------------------------------------------------------------
// Waveobt@̐擪AhXԂ
function TOggPlayer.Memory: Pointer;
begin
  result := FWaveBuffer.Memory;
end;

//------------------------------------------------------------------------------
// ŌɃ_O擪AhXԂ
function TOggPlayer.Offset: Pointer;
begin
  result := Pointer(DWORD(FWaveBuffer.Memory)+FWaveBufferPos);
end;

//------------------------------------------------------------------------------
// Waveobt@Ƀ_O
procedure TOggPlayer.Rendering;
var
  hlen : Integer;
  Ptr : PCHAR;
begin
  ThreadLock;

  hlen := FWaveBufferSize div 2;   //

  //OffZbgʒuvZ
  FPreWaveBufferPos := FWaveBufferPos;
  if (FWaveBufferPos = 0)then
  begin
    FWaveBufferPos := hlen;
    Ptr := FWaveBuffer.Memory;
    inc(Ptr,hlen);
  end
  else
  begin
    FWaveBufferPos := 0;
    Ptr := FWaveBuffer.Memory;
  end;
  
  RenderingToPointer(Ptr,hlen,FALSE);

  ThreadUnLock;
end;

//------------------------------------------------------------------------------
// ŏIo͐̉ʂ̕ςA^Cŋ߂
function TOggPlayer.GetMasterOutputSum: Single;
begin
  result := GetMasterOutputSum(2);
end;

function TOggPlayer.GetMasterOutputSum(c: Integer): Single;
var
  WavPos    : DWORD;
  SLR       : PLRWavePack16;
  BufMem    : DWORD;
  BufSize   : DWORD;
  i,p       : Integer;
  LVol,RVol : Integer;
begin
  result := 0;
  p := GetMasterOutputWavePos;   //ĐBuffer̈ʒu擾
  if (p = -1)then exit;

  ThreadLock;

  //pɂɎĝŃ[JŏێĂi
  BufSize := FWaveBufferSize;
  BufMem  := DWORD(FWaveBuffer.Memory);
  WavPos  := DWORD(p);
  //KȒ̔g`Ƃ肾āAΒl̕ς߂Ă
  LVol  := 0;
  RVol  := 0;
  for i:=0 to 255 do        //256
  begin
    WavPos:= WavPos mod BufSize;
    SLR   := Pointer(BufMem + WavPos);
    LVol  := LVol + abs(SLR.L);
    RVol  := RVol + abs(SLR.R);
    inc(WavPos,4);
  end;

  LVol := LVol div 256;
  RVol := RVol div 256;

  case c of
    0   : result := LVol / 32768;
    1   : result := RVol / 32768;
    else  result := (LVol+RVol) / 65536;
  end;

  ThreadUnLock;
end;

//------------------------------------------------------------------------------
// ߂
procedure TOggPlayer.Pause(ch: Integer);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].Pause;
end;

//------------------------------------------------------------------------------
// }X^[̌ݍĐ̈ʒuWaveBuffer̈ʒuŕԂ
// obt@ɂȂꍇ-1Ԃ
function TOggPlayer.GetMasterOutputWavePos: Integer;
var
  BufSize : Integer;
  TimePos : Single;
  WavPos  : Integer;
begin
  ThreadLock;

  result := -1;
  //WaveBuffer̃TCY
  BufSize := FWaveBufferSize;
  //BYTEi񂾂Zo
  TimePos:= (TimeGetTime - FLastRendTime)*(1/1000); // i񂾎ԂZo
  if (TimePos>10.0)then TimePos := 10.0;
  if (TimePos<0.0)then TimePos := 0.0;
  WavPos := Round(TimePos * (44100*2*2));        // msWAVEʒuɕϊ
  WavPos := WavPos and $FFFFFFFC;                // 4BYTEACgɍ킹
  if (WavPos>=BufSize)or(WavPos<0)then
  begin
    ThreadUnLock;
    exit;                // WaveBufferɂȂꍇ
  end;
  //FWaveBuffer̃AhX߂
  if (FWaveBufferPos = 0)then WavPos := WavPos + BufSize div 2;
  WavPos := WavPos mod BufSize;
  result := WavPos;

  ThreadUnLock;
end;

function TOggPlayer.GetOutputWavePos(ch: Integer): Integer;
begin
  result := -1;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].GetOutputWavePos;
end;

//------------------------------------------------------------------------------
// gʂԂ
procedure TOggPlayer.GetMasterOutputGraph(d:PSingle);
var
  WavPos    : DWORD;
  sPtr      : PSingle;
  BufMem    : DWORD;
  BufSize   : DWORD;
  i,p       : Integer;
  t         : Single;
  SLR       : PLRWavePack16;
begin
  p := GetMasterOutputWavePos;      //ĐBuffer̈ʒu擾
  if (p = -1)then exit;

  ThreadLock;

  //pɂɎĝŃ[JŏێĂi
  BufSize := FWaveBufferSize;
  BufMem  := DWORD(FWaveBuffer.Memory);
  WavPos  := DWORD(p);
  //KȒ̔g`Ƃ肾āAΒl̕ς߂Ă
  for i:=0 to 255 do        //256
  begin
    if (WavPos>=BufSize)then WavPos := 0;
    SLR   := Pointer(BufMem + WavPos);
    FFT2.re[i] := SLR^.L;
    FFT2.im[i] := SLR^.R;
    inc(WavPos,sizeof(TLRWavePack16));
  end;

  FFT2.HammingWindow;
  FFT2.FFT;
  FFT2.NormalizeFFT;     //g̃m[}CY

  // gggƕ̂ŁAggɕёւďo
  // āASinC
  sPtr := d;
  for i:=0 to 127 do
  begin
    t := (abs(FFT2.re[i])+abs(FFT2.im[i]))*0.5;
    sPtr^ := t;
    inc(sPtr);
    t := (abs(FFT2.re[255-i])+abs(FFT2.im[255-i]))*0.5;
    sPtr^ := t;
    inc(sPtr);
  end;

  ThreadUnLock;
end;


procedure TOggPlayer.GetoutputGraph(ch:Integer; d: PSingle);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].GetOutputGraph(d);
end;

//------------------------------------------------------------------------------
// ݂̃CRCU̒lԂ
function TOggPlayer.GetNowEQ(ch, h: Integer): Single;
begin
  result := 1.0;
  if (OggData[ch] = nil)then exit;
  result := OggData[ch].GetNowEQ(h);
end;

//------------------------------------------------------------------------------
// ݒ肵CRCU̒lԂ
function TOggPlayer.GetSetEQ(ch, h: Integer): Single;
begin
  result := 1.0;
  if (OggData[ch] = nil)then exit;
  result := Oggdata[ch].GetNowEQ(h);
end;

function TOggPlayer.GetSetPan(ch: Integer): Single;
begin
  RESULT := 0.0;
  if (OggData[ch] = nil)then exit;
  result := Oggdata[ch].GetSetPan;
end;

//------------------------------------------------------------------------------
// CRCUɒlZbg
procedure TOggPlayer.SetEQ(ch, h: Integer; v: Single);
begin
  SetEQ(ch,h,v,0.0);
end;

procedure TOggPlayer.SetEQ(ch, h: Integer; v, t: Single);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].SetEQ(h,v,t);
end;

//------------------------------------------------------------------------------
// ȈՃCRCUݒ
procedure TOggPlayer.SetEQ16(ch: Integer; v1, v2, v3, v4, v5, v6, v7, v8,
  v9, v10, v11, v12, v13, v14, v15, v16, t: Single);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].SetEQ16(v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,v13,v14,v15,v16,t);
end;

procedure TOggPlayer.SetEQ4(ch: Integer; v1, v2, v3, v4, t: Single);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].SetEQ4(v1,v2,v3,v4,t);
end;

procedure TOggPlayer.SetEQ8(ch: Integer; v1, v2, v3, v4, v5, v6, v7, v8,
  t: Single);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].SetEQ8(v1,v2,v3,v4,v5,v6,v7,v8,t);
end;

//------------------------------------------------------------------------------
// `l̂ւ
procedure TOggPlayer.Swap(ch1,ch2:Integer);
var
  a : TOggData;
begin
  ThreadLock;

  a            := OggData[ch1];
  OggData[ch1] := OggData[ch2];
  OggData[ch2] := a;

  ThreadUnLock;
end;

//------------------------------------------------------------------------------
//݂̃Xs[J痬Ă鎞ԂԂ
function TOggPlayer.GetOutputTime(ch: Integer): Single;
begin
  RESULT := 0.0;
  if (OggData[ch] = nil)then exit;

  RESULT := OggData[ch].GetOutputTime;
end;

function TOggPlayer.GetEQ(ch: Integer): Boolean;
begin
  result := FALSE;
  if (OggData[ch] = nil)then exit;

  result := OggData[ch].GetEQ;
end;

procedure TOggPlayer.SetMasterVolume(ch: Integer; v: Single);
begin
  if (OggData[ch] = nil)then exit;

  OggData[ch].SetMasterVolume(v);
end;

procedure TOggPlayer.WhiteSkip(ch, v: Integer);
begin
  if (OggData[ch] = nil)then exit;
  OggData[ch].WhiteSkip(v);
end;

function TOggPlayer.GetNowPan(ch: Integer): Single;
begin
  RESULT := 0.0;
  if (OggData[ch] = nil)then exit;
  result := Oggdata[ch].GetNowPan;
end;

function TOggPlayer.GetNowPlayState(ch: Integer): TPLAYSTATE;
begin
  result := psNONE;
  if (OggData[ch] = nil)then exit;

  result := OggData[ch].GetNowPlayState;
end;

procedure TOggPlayer.SetOutputVolume(v: Single);
begin
  ThreadLock;
  FOutputVolume := Round(v*256);
  ThreadUnLock;
end;

procedure TOggPlayer.SetPan(ch: Integer; v, t: Single);
begin
  if (OggData[ch] = nil)then exit;

  OggData[ch].SetPan(v,t);
end;

function TOggPlayer.PreOffset: pointer;
begin
  result := Pointer(DWORD(FWaveBuffer.Memory)+FPreWaveBufferPos);
end;

end.
