//
//      wuvorbis.dll INCu
//      coder:Ko-Ta
//
//  UPDATE
//      2003.11/07...vg
//      2003.11/08...ق

unit OggWuvorbisLib;

interface

uses Windows, SysUtils, Classes;

//OggVorbisDLLS͍\̂8BYTEACgŃRpCĂ
{$A8}

// =============================================================================
type
  LPCHAR        = ^CHAR;      //*
  LPPCHAR       = ^LPCHAR;    //**
  LPSingle      = ^Single;    //*
  LPPSingle     = ^LPSingle;  //**
  LPPPSingle    = ^LPPSingle; //***

type wu_OggVorbis_File = record
  data : array[0..704+256-1] of CHAR;
end;
type LPwu_OggVorbis_File = ^wu_OggVorbis_File;

type wu_vorbis_info = record
  version	: Integer;
  channels	: Integer;
  rate  	: LongInt;

  bitrate_upper	    : LongInt;
  bitrate_nominal	: LongInt;
  bitrate_lower	    : LongInt;
  bitrate_window	: LongInt;
  codec_setup	    : Pointer;
end;
type LPwu_vorbis_info = ^wu_vorbis_info;

type wu_vorbis_comment = record
  user_comments	    : LPPChar;
  comment_lengths	: PInteger;
  comments	        : Integer;
  vendor	        : PChar;
end;
type LPwu_vorbis_comment = ^wu_vorbis_comment;

type ov_read_func = function(ptr:Pointer; size,nmemb:DWORD; datasource:Pointer):DWORD; cdecl;
type ov_seek_func = function(datasource:Pointer; offset:int64; whence:Integer):Integer; cdecl;
type ov_close_func= function(datasource:Pointer):Integer; cdecl;
type ov_tell_func = function(datasource:Pointer):LongInt; cdecl;
type wu_ov_callbacks = record
  read_func : ov_read_func;
  seek_func : ov_seek_func;
  close_func: ov_close_func;
  tell_func : ov_tell_func;
end;

const
  WU_NOTOPEN  = 0;
  WU_PARTOPEN = 1;
  WU_OPENED   = 2;
  WU_STREAMSET= 3;
  WU_INITSET  = 4;
  WU_OV_FALSE = -1;
  WU_OV_EOF   = -2;
  WU_OV_HOLE  = -3;
  WU_OV_EREAD = -128;
  WU_OV_EFAULT= -129;
  WU_OV_EIMPL = -130;
  WU_OV_EINVAL= -131;
  WU_OV_ENOTVORBIS = -132;
  WU_OV_EBADHEADER = -133;
  WU_OV_EVERSION   = -134;
  WU_OV_ENOTAUDIO  = -135;
  WU_OV_EBADPACKET = -136;
  WU_OV_EBADLINK   = -137;
  WU_OV_ENOSEEK    = -138;
  WU_CPU_HAS_FPU  = $000010000;
  WU_CPU_HAS_MMX  = $000020000;
  WU_CPU_HAS_3DN  = $000040000;
  WU_CPU_HAS_SSE  = $000080000;
  WU_CPU_HAS_CMOV = $000100000;
  WU_CPU_HAS_E3DN = $000200000;
  WU_CPU_HAS_EMMX = $000400000;
  WU_CPU_HAS_SSE2 = $000800000;
  WU_CPU_HAS_TSC  = $001000000;
  WU_CPU_FEATURE_MASK = $0ffff0000;
  WU_CPU_IS_INTEL = $000000010;
  WU_CPU_IS_AMD   = $000000020;
  WU_CPU_IS_IDT   = $000000030;
  WU_CPU_IS_CYRIX = $000000040;
  WU_CPU_IS_NEXGEN = $000000050;
  WU_CPU_IS_RISE  = $000000060;
  WU_CPU_IS_UMC   = $000000070;
  WU_CPU_IS_TRANSMETA = $000000080;
  WU_CPU_IS_UNKNOWN = $000000000;
  WU_CPU_VENDOR_MASK = $000000ff0;
  WU_CPU_FAMILY_MASK = $00000000f;

type
  Twu_ov_clear = function(var vf:wu_OggVorbis_File):Integer; cdecl;
  Twu_ov_open_callbacks = function(datasource: Pointer; var vf:wu_OggVorbis_File; initial:PChar; ibytes:LongInt; callbacks:wu_ov_callbacks): Integer; cdecl;
  Twu_ov_test_callbacks = function(datasource: Pointer; var vf:wu_OggVorbis_File; initial:PChar; ibytes:LongInt; callbacks:wu_ov_callbacks): Integer; cdecl;
  Twu_ov_test_open = function(var vf:wu_OggVorbis_File):Integer; cdecl;
  //extern int  (_cdecl *wu_ov_test_open)(wu_OggVorbis_File *vf);
  Twu_ov_bitrate = function(var vf:wu_OggVorbis_File; i:Integer):LongInt; cdecl;
  //extern long  (_cdecl *wu_ov_bitrate)(wu_OggVorbis_File *vf,int i);
  Twu_ov_bitrate_instant = function(var vf:wu_OggVorbis_File):LongInt; cdecl;
  //extern long  (_cdecl *wu_ov_bitrate_instant)(wu_OggVorbis_File *vf);
  Twu_ov_streams = function(var vf:wu_OggVorbis_File):LongInt; cdecl;
  //extern long  (_cdecl *wu_ov_streams)(wu_OggVorbis_File *vf);
  Twu_ov_seekable = function(var vf:wu_OggVorbis_File):LongInt; cdecl;
  //extern long  (_cdecl *wu_ov_seekable)(wu_OggVorbis_File *vf);
  Twu_ov_serialnumber = function(var vf:wu_OggVorbis_File; i:Integer):LongInt; cdecl;
  //extern long  (_cdecl *wu_ov_serialnumber)(wu_OggVorbis_File *vf,int i);
  Twu_ov_raw_total = function(var vf:wu_OggVorbis_File; i:Integer):Int64; cdecl;
  //extern wu_ogg_int64_t  (_cdecl *wu_ov_raw_total)(wu_OggVorbis_File *vf,int i);
  Twu_ov_pcm_total = function(var vf:wu_OggVorbis_File; i:Integer):Int64; cdecl;
  //extern wu_ogg_int64_t  (_cdecl *wu_ov_pcm_total)(wu_OggVorbis_File *vf,int i);
  Twu_ov_time_total= function(var vf:wu_OggVorbis_File; i:Integer):Double; cdecl;
  //extern double  (_cdecl *wu_ov_time_total)(wu_OggVorbis_File *vf,int i);
  Twu_ov_raw_seek = function(var vf:wu_OggVorbis_File; pos:Int64):Integer; cdecl;
  //extern int  (_cdecl *wu_ov_raw_seek)(wu_OggVorbis_File *vf,wu_ogg_int64_t pos);
  Twu_ov_pcm_seek = function(var vf:wu_OggVorbis_File; pos:Int64):Integer; cdecl;
  //extern int  (_cdecl *wu_ov_pcm_seek)(wu_OggVorbis_File *vf,wu_ogg_int64_t pos);
  Twu_ov_pcm_seek_page = function(var vf:wu_OggVorbis_File; pos:Int64):Integer; cdecl;
  //extern int  (_cdecl *wu_ov_pcm_seek_page)(wu_OggVorbis_File *vf,wu_ogg_int64_t pos);
  Twu_ov_time_seek = function(var vf:wu_OggVorbis_File; pos:double):Integer; cdecl;
  //extern int  (_cdecl *wu_ov_time_seek)(wu_OggVorbis_File *vf,double pos);
  Twu_ov_time_seek_page = function(var vf:wu_OggVorbis_File; pos:double):Integer; cdecl;
  //extern int  (_cdecl *wu_ov_time_seek_page)(wu_OggVorbis_File *vf,double pos);
  Twu_ov_raw_seek_lap = function(var vf:wu_OggVorbis_File; pos:Int64):Integer; cdecl;
  //extern int  (_cdecl *wu_ov_raw_seek_lap)(wu_OggVorbis_File *vf,wu_ogg_int64_t pos);
  Twu_ov_pcm_seek_lap = function(var vf:wu_OggVorbis_File; pos:Int64):Integer; cdecl;
  //extern int  (_cdecl *wu_ov_pcm_seek_lap)(wu_OggVorbis_File *vf,wu_ogg_int64_t pos);
  Twu_ov_pcm_seek_page_lap = function(var vf:wu_OggVorbis_File; pos:Int64):Integer; cdecl;
  //extern int  (_cdecl *wu_ov_pcm_seek_page_lap)(wu_OggVorbis_File *vf,wu_ogg_int64_t pos);
  Twu_ov_time_seek_lap = function(var vf:wu_OggVorbis_File; pos:double):Integer; cdecl;
  //extern int  (_cdecl *wu_ov_time_seek_lap)(wu_OggVorbis_File *vf,double pos);
  Twu_ov_time_seek_page_lap = function(var vf:wu_OggVorbis_File; pos:double):Integer; cdecl;
  //extern int  (_cdecl *wu_ov_time_seek_page_lap)(wu_OggVorbis_File *vf,double pos);
  Twu_ov_raw_tell = function(var vf:wu_OggVorbis_File):Int64; cdecl;
  //extern wu_ogg_int64_t  (_cdecl *wu_ov_raw_tell)(wu_OggVorbis_File *vf);
  Twu_ov_pcm_tell = function(var vf:wu_OggVorbis_File):Int64; cdecl;
  //extern wu_ogg_int64_t  (_cdecl *wu_ov_pcm_tell)(wu_OggVorbis_File *vf);
  Twu_ov_time_tell = function(var vf:wu_OggVorbis_File):Double; cdecl;
  //extern double  (_cdecl *wu_ov_time_tell)(wu_OggVorbis_File *vf);
  Twu_ov_info = function(var vf: wu_OggVorbis_File; link: Integer): LPwu_vorbis_info; cdecl;
  //extern wu_vorbis_info * (_cdecl *wu_ov_info)(wu_OggVorbis_File *vf,int link);
  Twu_ov_comment = function(var vf: wu_OggVorbis_File; link: Integer):LPwu_vorbis_comment; cdecl;
  //extern wu_vorbis_comment * (_cdecl *wu_ov_comment)(wu_OggVorbis_File *vf,int link);
  Twu_ov_read_float = function(var vf: wu_OggVorbis_File; pcm_channels:LPPPSingle; sample:Integer; var bitstream: Integer): LongInt; cdecl;
  //extern long  (_cdecl *wu_ov_read_float)(wu_OggVorbis_File *vf,float ***pcm_channels,int samples,			  int *bitstream);
  Twu_ov_read = function(var vf: wu_OggVorbis_File; buffer:PChar; length:Integer;bigendianp: Integer; word: Integer; sgned: Integer; var bitstream: Integer): LongInt; cdecl;
  //extern long  (_cdecl *wu_ov_read)(wu_OggVorbis_File *vf,char *buffer,int length,		    int bigendianp,int word,int sgned,int *bitstream);
  Twu_ov_crosslap = function(var vf1,vf2: wu_OggVorbis_File):Integer; cdecl;
  //extern int  (_cdecl *wu_ov_crosslap)(wu_OggVorbis_File *vf1,wu_OggVorbis_File *vf2);
  Twu_SetCPUType = procedure(_type:DWORD); cdecl;
  //extern void  (_cdecl *wu_SetCPUType)(unsigned __int32 type);
  Twu_DetectCPU = function : Integer; cdecl;
  //extern unsigned __int32  (_cdecl *wu_DetectCPU)(void);
  Twu_ScaleOutput = procedure(scale:single); cdecl;
  //extern void  (_cdecl *wu_ScaleOutput)(float scale);

// =============================================================================
// CallBack֐
function _fread(ptr:Pointer; size:DWORD; nmemb:DWORD; datasource:Pointer):DWORD; cdecl;
function _fseek(datasource:Pointer; offset:Int64; whence:Integer):Integer; cdecl;
function _fclose(datasource:Pointer):Integer; cdecl;
function _ftell(datasource:Pointer):LongInt; cdecl;

// VorbisFileDLLǂݍ݃NX
type TVorbisFileDLL = class
  private
  protected
    // DLL
    FDLLH    : THandle;
    FDLLName : String;
    FExCPUCode : Boolean;
    // ֐S
    //g
    Fwu_SetCPUType    : Twu_SetCPUType;
    Fwu_DetectCPU     : Twu_DetectCPU;
    Fwu_ScaleOutput   : Twu_ScaleOutput;
    //OggW
    Fwu_ov_info          : Twu_ov_info;
    Fwu_ov_clear         : Twu_ov_clear;
    Fwu_ov_open_callbacks: Twu_ov_open_callbacks;
    Fwu_ov_test_callbacks: Twu_ov_test_callbacks;
    Fwu_ov_test_open     : Twu_ov_test_open;
    Fwu_ov_bitrate       : Twu_ov_bitrate;
    Fwu_ov_bitrate_instant:Twu_ov_bitrate_instant;
    Fwu_ov_streams       : Twu_ov_streams;
    Fwu_ov_serialnumber  : Twu_ov_serialnumber;
    Fwu_ov_seekable      : Twu_ov_seekable;
    Fwu_ov_raw_total     : Twu_ov_raw_total;
    Fwu_ov_time_total    : Twu_ov_time_total;
    Fwu_ov_pcm_total     : Twu_ov_pcm_total;
    Fwu_ov_raw_seek      : Twu_ov_raw_seek;
    Fwu_ov_pcm_seek      : Twu_ov_pcm_seek;
    Fwu_ov_pcm_seek_page : Twu_ov_pcm_seek_page;
    Fwu_ov_time_seek     : Twu_ov_time_seek;
    Fwu_ov_time_seek_page: Twu_ov_time_seek_page;
    Fwu_ov_raw_seek_lap  : Twu_ov_raw_seek_lap;
    Fwu_ov_pcm_seek_lap  : Twu_ov_pcm_seek_lap;
    Fwu_ov_pcm_seek_page_lap:Twu_ov_pcm_seek_page_lap;
    Fwu_ov_time_seek_lap : Twu_ov_time_seek_lap;
    Fwu_ov_time_seek_page_lap:Twu_ov_time_seek_page_lap;
    Fwu_ov_raw_tell      : Twu_ov_raw_tell;
    Fwu_ov_pcm_tell      : Twu_ov_pcm_tell;
    Fwu_ov_time_tell     : Twu_ov_time_tell;
    Fwu_ov_comment       : Twu_ov_comment;
    Fwu_ov_read_float    : Twu_ov_read_float;
    Fwu_ov_read          : Twu_ov_read;
    Fwu_ov_crosslap      : Twu_ov_crosslap;

    //CallBack֐Zbg\
    Fcallbacks           : wu_ov_callbacks;

    procedure   SetProcessAddress(var p; procname:String);
  public
    constructor Create(ExCPUCode:Boolean=TRUE);
    function    LoadFromDLL(filename:string):Boolean;
    destructor  Destroy; override;

    //g
    procedure wu_SetCPUType(_type:DWORD);
    function  wu_DetectCPU:Integer;
    procedure wu_ScaleOutput(scale:single);
    //OggVorbis`
   { function wu_ov_clear(var vf: wu_OggVorbis_File): Integer;
    function wu_ov_open_callbacks(datasource: Pointer; var vf: wu_OggVorbis_File; initial: PChar; ibytes: LongInt): Integer;
    function wu_ov_info(var vf: wu_OggVorbis_File; link: Integer): LPwu_vorbis_info;
    function wu_ov_comment(var vf:wu_OggVorbis_File; link: Integer): LPwu_vorbis_comment;
    function wu_ov_read(var vf: wu_OggVorbis_File; buffer: PChar; length: Integer; bigendianp: Integer; word: Integer; sgned: Integer; var bitstream: Integer): LongInt;
    function wu_ov_time_total(var vf:wu_OggVorbis_File; i: Integer): double;
    function wu_ov_time_seek(var vf:wu_OggVorbis_File; pos: double): Integer;
    function wu_ov_time_tell(var vf:wu_OggVorbis_File): double;
    function wu_ov_pcm_total(var vf:wu_OggVorbis_File; i: Integer): Int64;
    function wu_ov_seekable(var vf:wu_OggVorbis_File) : Integer;
    }

    function wu_ov_clear(var vf:wu_OggVorbis_File):Integer;
    function wu_ov_open_callbacks(datasource: Pointer; var vf:wu_OggVorbis_File; initial:PChar; ibytes:LongInt; callbacks:wu_ov_callbacks): Integer; overload;
    function wu_ov_open_callbacks(datasource: Pointer; var vf:wu_OggVorbis_File; initial:PChar; ibytes:LongInt): Integer; overload;
    function wu_ov_test_callbacks(datasource: Pointer; var vf:wu_OggVorbis_File; initial:PChar; ibytes:LongInt; callbacks:wu_ov_callbacks): Integer; overload;
    function wu_ov_test_callbacks(datasource: Pointer; var vf:wu_OggVorbis_File; initial:PChar; ibytes:LongInt): Integer; overload;
    function wu_ov_test_open(var vf:wu_OggVorbis_File):Integer;
    function wu_ov_bitrate(var vf:wu_OggVorbis_File; i:Integer):LongInt;
    function wu_ov_bitrate_instant(var vf:wu_OggVorbis_File):LongInt;
    function wu_ov_streams(var vf:wu_OggVorbis_File):LongInt;
    function wu_ov_seekable(var vf:wu_OggVorbis_File):LongInt;
    function wu_ov_serialnumber(var vf:wu_OggVorbis_File; i:Integer):LongInt;
    function wu_ov_raw_total(var vf:wu_OggVorbis_File; i:Integer):Int64;
    function wu_ov_pcm_total(var vf:wu_OggVorbis_File; i:Integer):Int64;
    function wu_ov_time_total(var vf:wu_OggVorbis_File; i:Integer):Double;
    function wu_ov_raw_seek(var vf:wu_OggVorbis_File; pos:Int64):Integer;
    function wu_ov_pcm_seek(var vf:wu_OggVorbis_File; pos:Int64):Integer;
    function wu_ov_pcm_seek_page(var vf:wu_OggVorbis_File; pos:Int64):Integer;
    function wu_ov_time_seek(var vf:wu_OggVorbis_File; pos:double):Integer;
    function wu_ov_time_seek_page(var vf:wu_OggVorbis_File; pos:double):Integer;
    function wu_ov_raw_seek_lap(var vf:wu_OggVorbis_File; pos:Int64):Integer;
    function wu_ov_pcm_seek_lap(var vf:wu_OggVorbis_File; pos:Int64):Integer;
    function wu_ov_pcm_seek_page_lap(var vf:wu_OggVorbis_File; pos:Int64):Integer;
    function wu_ov_time_seek_lap(var vf:wu_OggVorbis_File; pos:double):Integer;
    function wu_ov_time_seek_page_lap(var vf:wu_OggVorbis_File; pos:double):Integer;
    function wu_ov_raw_tell(var vf:wu_OggVorbis_File):Int64;
    function wu_ov_pcm_tell(var vf:wu_OggVorbis_File):Int64;
    function wu_ov_time_tell(var vf:wu_OggVorbis_File):Double;
    function wu_ov_info(var vf: wu_OggVorbis_File; link: Integer): LPwu_vorbis_info;
    function wu_ov_comment(var vf: wu_OggVorbis_File; link: Integer):LPwu_vorbis_comment;
    function wu_ov_read_float(var vf: wu_OggVorbis_File; pcm_channels:LPPPSingle; sample:Integer; var bitstream: Integer): LongInt;
    function wu_ov_read(var vf: wu_OggVorbis_File; buffer:PChar; length:Integer;bigendianp: Integer; word: Integer; sgned: Integer; var bitstream: Integer): LongInt;
    function wu_ov_crosslap(var vf1,vf2: wu_OggVorbis_File):Integer;
end;

function  _VorbisfileInitialize(filename:string):Boolean;
procedure _VorbisfileFinalize;

var
  _VorbisfileDll : TVorbisfileDLL = nil;

implementation

//------------------------------------------------------------------------------
//Vorbisfile.DLLǗ[`
function _VorbisfileInitialize(filename:string):Boolean;
begin
  _VorbisfileFinalize;
  _VorbisfileDll := TVorbisfileDll.Create(TRUE);
  RESULT := _VorbisfileDll.LoadFromDLL(filename);
end;

procedure _VorbisfileFinalize;
begin
  _VorbisfileDll.Free;
  _VorbisfileDll := nil;
end;

//------------------------------------------------------------------------------
// callback֐ iTMemoryStream̊)
// stdcallŗ\񂷂ƃ_ۂBȂ̂cdeclŗ\񂵂Ă
function _fread(ptr:Pointer; size:DWORD; nmemb:DWORD; datasource:Pointer):DWORD; cdecl;
begin
  if (size = 0) or (nmemb = 0) then
    Result := 0
  else
    Result := TMemoryStream(datasource).Read(ptr^,size*nmemb);
end;
function _fseek(datasource:Pointer; offset:Int64; whence:Integer):Integer; cdecl;
begin
  Result := TMemoryStream(datasource).Seek(offset,whence);
end;
function _fclose(datasource:Pointer):Integer; cdecl;
begin
  TMemoryStream(datasource).Free;
  Result := 0;
end;
function _ftell(datasource:Pointer):LongInt; cdecl;
begin
  Result := TMemoryStream(datasource).Position;
end;

//------------------------------------------------------------------------------
{ TVorbisFileDLL }

constructor TVorbisFileDLL.Create(ExCPUCode:Boolean);
begin
  FExCPUCode := ExCPUCode;
end;

destructor TVorbisFileDLL.Destroy;
begin

  // DLL̔j
  if (FDLLH <> 0) then FreeLibrary(FDLLH);
  FDLLH := 0;

  inherited;
end;

function TVorbisFileDLL.wu_ov_clear(var vf: wu_OggVorbis_File): Integer;
begin
  RESULT := Fwu_ov_clear(vf);
end;

function TVorbisFileDLL.wu_ov_comment(var vf: wu_OggVorbis_File;
  link: Integer): LPwu_vorbis_comment;
begin
  RESULT := Fwu_ov_comment(vf,link);
end;

function TVorbisFileDLL.wu_ov_info(var vf: wu_OggVorbis_File;
  link: Integer): LPwu_vorbis_info;
begin
  RESULT := Fwu_ov_info(vf,link);
end;

function TVorbisFileDLL.wu_ov_open_callbacks(datasource: Pointer; var vf:wu_OggVorbis_File; initial:PChar; ibytes:LongInt; callbacks:wu_ov_callbacks): Integer;
begin
  RESULT := Fwu_ov_open_callbacks(datasource,vf,initial,ibytes,callbacks);
end;

function TVorbisFileDLL.wu_ov_pcm_total(var vf: wu_OggVorbis_File;
  i: Integer): Int64;
begin
  RESULT := Fwu_ov_pcm_total(vf,i);
end;

function TVorbisFileDLL.wu_ov_read(var vf: wu_OggVorbis_File; buffer: PChar;
  length, bigendianp, word, sgned: Integer;
  var bitstream: Integer): LongInt;
begin
  RESULT := Fwu_ov_read(vf,buffer,length,bigendianp,word,sgned,bitstream);
end;

function TVorbisFileDLL.wu_ov_seekable(var vf: wu_OggVorbis_File): Integer;
begin
  RESULT := Fwu_ov_seekable(vf);
end;

function TVorbisFileDLL.wu_ov_time_seek(var vf: wu_OggVorbis_File;
  pos: double): Integer;
begin
  RESULT := Fwu_ov_time_seek(vf,pos);
end;

function TVorbisFileDLL.wu_ov_time_tell(var vf: wu_OggVorbis_File): double;
begin
  RESULT := Fwu_ov_time_tell(vf);
end;

function TVorbisFileDLL.wu_ov_time_total(var vf: wu_OggVorbis_File;
  i: Integer): double;
begin
  RESULT := Fwu_ov_time_total(vf,i);
end;

procedure TVorbisFileDLL.SetProcessAddress(var p; procname: String);
begin
  Pointer(p) := GetProcAddress(FDLLH,pchar(procname));
  if (Pointer(p) = nil)then
  begin
    raise ERangeError.CreateFmt('֐(%s)̏Ɏs܂',[procname]);
  end;
end;

function TVorbisFileDLL.wu_DetectCPU: Integer;
begin
  RESULT := Fwu_DetectCPU;
end;

procedure TVorbisFileDLL.wu_ScaleOutput(scale: single);
begin
  Fwu_ScaleOutput(scale);
end;

procedure TVorbisFileDLL.wu_SetCPUType(_type: DWORD);
begin
  Fwu_SetCPUType(_type);
end;


function TVorbisFileDLL.wu_ov_bitrate(var vf: wu_OggVorbis_File;
  i: Integer): LongInt;
begin
  RESULT := Fwu_ov_bitrate(vf,i);
end;

function TVorbisFileDLL.wu_ov_bitrate_instant(
  var vf: wu_OggVorbis_File): LongInt;
begin
  RESULT := Fwu_ov_bitrate_instant(vf);
end;

function TVorbisFileDLL.wu_ov_crosslap(var vf1,
  vf2: wu_OggVorbis_File): Integer;
begin
  RESULT := Fwu_ov_crosslap(vf1,vf2);
end;

function TVorbisFileDLL.wu_ov_pcm_seek(var vf: wu_OggVorbis_File;
  pos: Int64): Integer;
begin
  RESULT := Fwu_ov_pcm_seek(vf,pos);
end;

function TVorbisFileDLL.wu_ov_pcm_seek_lap(var vf: wu_OggVorbis_File;
  pos: Int64): Integer;
begin
  RESULT := Fwu_ov_pcm_seek_lap(vf,pos);
end;

function TVorbisFileDLL.wu_ov_pcm_seek_page(var vf: wu_OggVorbis_File;
  pos: Int64): Integer;
begin
  RESULT := Fwu_ov_pcm_seek_page(vf,pos);
end;

function TVorbisFileDLL.wu_ov_pcm_seek_page_lap(var vf: wu_OggVorbis_File;
  pos: Int64): Integer;
begin
  RESULT := Fwu_ov_pcm_seek_page_lap(vf,pos);
end;

function TVorbisFileDLL.wu_ov_pcm_tell(var vf: wu_OggVorbis_File): Int64;
begin
  RESULT := Fwu_ov_pcm_tell(vf);
end;

function TVorbisFileDLL.wu_ov_raw_seek(var vf: wu_OggVorbis_File;
  pos: Int64): Integer;
begin
  RESULT := Fwu_ov_raw_seek(vf,pos);
end;

function TVorbisFileDLL.wu_ov_raw_seek_lap(var vf: wu_OggVorbis_File;
  pos: Int64): Integer;
begin
  RESULT := Fwu_ov_raw_seek_lap(vf,pos);
end;

function TVorbisFileDLL.wu_ov_raw_tell(var vf: wu_OggVorbis_File): Int64;
begin
  RESULT := Fwu_ov_raw_tell(vf);
end;

function TVorbisFileDLL.wu_ov_raw_total(var vf: wu_OggVorbis_File;
  i: Integer): Int64;
begin
  RESULT := Fwu_ov_raw_total(vf,i);
end;

function TVorbisFileDLL.wu_ov_read_float(var vf: wu_OggVorbis_File;
  pcm_channels: LPPPSingle; sample: Integer;
  var bitstream: Integer): LongInt;
begin
  RESULT := Fwu_ov_read_float(vf,pcm_channels,sample,bitstream);
end;

function TVorbisFileDLL.wu_ov_serialnumber(var vf: wu_OggVorbis_File;
  i: Integer): LongInt;
begin
  RESULT := Fwu_ov_serialnumber(vf,i);
end;

function TVorbisFileDLL.wu_ov_streams(var vf: wu_OggVorbis_File): LongInt;
begin
  RESULT := Fwu_ov_streams(vf);
end;

function TVorbisFileDLL.wu_ov_test_callbacks(datasource: Pointer;
  var vf: wu_OggVorbis_File; initial: PChar; ibytes: Integer;
  callbacks: wu_ov_callbacks): Integer;
begin
  RESULT := Fwu_ov_test_callbacks(datasource,vf,initial,ibytes,callbacks);
end;

function TVorbisFileDLL.wu_ov_test_open(
  var vf: wu_OggVorbis_File): Integer;
begin
  RESULT := Fwu_ov_test_open(vf);
end;

function TVorbisFileDLL.wu_ov_time_seek_lap(var vf: wu_OggVorbis_File;
  pos: double): Integer;
begin
  RESULT := Fwu_ov_time_seek_lap(vf,pos);
end;

function TVorbisFileDLL.wu_ov_time_seek_page(var vf: wu_OggVorbis_File;
  pos: double): Integer;
begin
  RESULT := Fwu_ov_time_seek_page(vf,pos);
end;

function TVorbisFileDLL.wu_ov_time_seek_page_lap(var vf: wu_OggVorbis_File;
  pos: double): Integer;
begin
  RESULT := Fwu_ov_time_seek_page_lap(vf,pos);
end;

function TVorbisFileDLL.wu_ov_open_callbacks(datasource: Pointer;
  var vf: wu_OggVorbis_File; initial: PChar; ibytes: Integer): Integer;
begin
  RESULT := Fwu_ov_open_callbacks(datasource,vf,initial,ibytes,Fcallbacks);
end;

function TVorbisFileDLL.wu_ov_test_callbacks(datasource: Pointer;
  var vf: wu_OggVorbis_File; initial: PChar; ibytes: Integer): Integer;
begin
  RESULT := Fwu_ov_test_callbacks(datasource,vf,initial,ibytes,Fcallbacks);
end;

function TVorbisFileDLL.LoadFromDLL(filename: string): Boolean;
var
  s : String;
  aaa : DWORD;
  c : array[0..255] of char;
begin
  RESULT := FALSE;
  //DLL̓ǂݍ
  try
    //΃pX炤
    s := ExpandFileName(Filename);
    // DLLĂяo
    FDLLH := LoadLibrary(pchar(s));

    //Ăяoǂ
    if(FDLLH = 0) then
    begin
      raise ERangeError.CreateFmt('wuvorbis.dll̓ǂݍ݂ɎsB'+#13+#10+'(%s)',[s]);
      exit;
    end;
  except
    raise ERangeError.CreateFmt('wuvorbis.dll݂܂B'+#13+#10+'(%s)',[s]);
    exit;
  end;

  //W[̎擾
  if GetModuleFileName(FDLLH, c, 255) > 0 then
    FDLLName := c
  else
    FDLLName := 'vorbisfile.dll';

  try
    //g
    SetProcessAddress(Fwu_SetCPUType    ,'wu_SetCPUType');
    SetProcessAddress(Fwu_DetectCPU     ,'wu_DetectCPU');
    SetProcessAddress(Fwu_ScaleOutput   ,'wu_ScaleOutput');
    //OggVorbisW
    SetProcessAddress(Fwu_ov_info          ,'wu_ov_info');
    SetProcessAddress(Fwu_ov_clear         ,'wu_ov_clear');
    SetProcessAddress(Fwu_ov_open_callbacks,'wu_ov_open_callbacks');
    SetProcessAddress(Fwu_ov_test_callbacks,'wu_ov_test_callbacks');
    SetProcessAddress(Fwu_ov_test_open     ,'wu_ov_test_open');
    SetProcessAddress(Fwu_ov_bitrate       ,'wu_ov_bitrate');
    SetProcessAddress(Fwu_ov_bitrate_instant,'wu_ov_bitrate_instant');
    SetProcessAddress(Fwu_ov_streams       ,'wu_ov_streams');
    SetProcessAddress(Fwu_ov_serialnumber  ,'wu_ov_serialnumber');
    SetProcessAddress(Fwu_ov_seekable      ,'wu_ov_seekable');
    SetProcessAddress(Fwu_ov_raw_total     ,'wu_ov_raw_total');
    SetProcessAddress(Fwu_ov_time_total    ,'wu_ov_time_total');
    SetProcessAddress(Fwu_ov_pcm_total     ,'wu_ov_pcm_total');
    SetProcessAddress(Fwu_ov_raw_seek      ,'wu_ov_raw_seek');
    SetProcessAddress(Fwu_ov_pcm_seek      ,'wu_ov_pcm_seek');
    SetProcessAddress(Fwu_ov_pcm_seek_page ,'wu_ov_pcm_seek_page');
    SetProcessAddress(Fwu_ov_time_seek     ,'wu_ov_time_seek');
    SetProcessAddress(Fwu_ov_time_seek_page,'wu_ov_time_seek_page');
    SetProcessAddress(Fwu_ov_raw_seek_lap  ,'wu_ov_raw_seek_lap');
    SetProcessAddress(Fwu_ov_pcm_seek_lap  ,'wu_ov_pcm_seek_lap');
    SetProcessAddress(Fwu_ov_pcm_seek_page_lap,'wu_ov_pcm_seek_page_lap');
    SetProcessAddress(Fwu_ov_time_seek_lap ,'wu_ov_time_seek_lap');
    SetProcessAddress(Fwu_ov_time_seek_page_lap,'wu_ov_time_seek_page_lap');
    SetProcessAddress(Fwu_ov_raw_tell      ,'wu_ov_raw_tell');
    SetProcessAddress(Fwu_ov_pcm_tell      ,'wu_ov_pcm_tell');
    SetProcessAddress(Fwu_ov_time_tell     ,'wu_ov_time_tell');
    SetProcessAddress(Fwu_ov_comment       ,'wu_ov_comment');
    SetProcessAddress(Fwu_ov_read_float    ,'wu_ov_read_float');
    SetProcessAddress(Fwu_ov_read          ,'wu_ov_read');
    SetProcessAddress(Fwu_ov_crosslap      ,'wu_ov_crosslap');
  except
    exit;
  end;
  
  // CallBack֐̃AhXi[Ƃ
  Fcallbacks.read_func := @_fread;
  Fcallbacks.seek_func := @_fseek;
  Fcallbacks.close_func:= @_fclose;
  Fcallbacks.tell_func := @_ftell;

  //CPŮgAZugpႤ
  if (FExCPUCode)then
  begin
    aaa := wu_DetectCPU;
    wu_SetCPUType(aaa);// and (WU_CPU_HAS_MMX+WU_CPU_HAS_3DN+WU_CPU_HAS_SSE));
  end;

  RESULT := TRUE;
end;

end.
