unit uAGC;

interface

uses Windows, SysUtils, StrUtils, Classes;

type
 TAutoAmpStuff = Record
   gain  : Single;
   delay : Integer;
   Count : integer;
   High  : integer;
   quiet : integer;
 end;

type TAGC=class
  protected
    FAmpStuff : TAutoAmpStuff;
  public
    AmpGain : Single;
    AmpTarget : Integer;
    AmpQuiet  : Integer;
    AmpRate   : Single;

    constructor Create;
    destructor  Destroy; override;
    procedure   Init;
    procedure   Refresh;

    procedure   Rendering(ptr:Pointer; Len:Integer);
end;


implementation

{
procedure DoAutoAmp(Handle, Channel: DWORD; Buffer: Pointer; BufLen, Amp: DWORD); stdcall;
var
 Data: ^Smallint;
 s, sa: Integer;
begin
 Data := Buffer;
 while (BufLen > 0) do
 begin
   s  := Trunc(Data^ * AmpStuff.gain);
   sa := Abs(s);
   if abs(data^) < ampquiet then
     Inc(AmpStuff.quiet)                              // sample is below quiet level
   else
     AmpStuff.quiet := 0;

   if sa < amptarget then                         // amplified level is below target
   begin
     if sa > AmpStuff.High then AmpStuff.High := sa;
     Inc(AmpStuff.Count);
     if AmpStuff.Count > AmpStuff.delay then              // been below target for a while
     begin
       if AmpStuff.quiet > AmpStuff.delay then            // it's quiet, go back towards normal level
       begin
           AmpStuff.gain := AmpStuff.gain + (10 * amprate * (1 - AmpStuff.gain));
       end
       else begin
         // increase amp
         AmpStuff.gain := AmpStuff.gain + (amprate * (amptarget / AmpStuff.High));
         AmpStuff.High  := 0;
         AmpStuff.Count := 0;                           // reset counts
     end;
   end
   else begin                                     // amplified level is above target
     if s < -32768 then s := -32768
     else if s > 32767 then s := 32767;
     AmpStuff.gain  := AmpStuff.gain - (amprate * (sa / amptarget)); // decrease amp
     AmpStuff.High  := 0;
     AmpStuff.Count := 0;
   end;
   data^ := Smallint(s);                          // replace original sample with amplified version
   Inc(Data);
   Dec(Buflen, 2);
 end;
end;


procedure LoadFile(AFile: TFileName);
begin
 // do whatever you do to load the file
 FStream := BASS_StreamCreateFile(FALSE, PChar(AFile), 0, 0, 0);

 AmpStuff.gain  := 1;
 AmpStuff.delay := Trunc((BASS_ChannelSeconds2Bytes(FChannels[FCurChan].Stream, 1) / 2));
 AmpStuff.Count := 0;
 AmpStuff.High  := 0;
 AmpStuff.quiet := 0;

 BASS_ChannelSetDSP(FStream, @DoAutoAmp, 0);
end;
}


{ TAGC }

constructor TAGC.Create;
begin
  AmpTarget := 30000;
  AmpQuiet  := 800;
  AmpRate   := 0.05;
  AmpGain   := 1.0;
  Init;
end;

destructor TAGC.Destroy;
begin
  Init;
  
  inherited;
end;

procedure TAGC.Init;
begin
  Refresh;
  FAmpStuff.Count := 0;
  FAmpStuff.High  := 0;
  FAmpStuff.quiet := 0;
end;

procedure TAGC.Refresh;
begin
  FAmpStuff.gain  := AmpGain;
  FAmpStuff.delay := 1024*12;
end;

procedure TAGC.Rendering(ptr: Pointer; Len: Integer);
var
  Data : ^SmallInt;
  s, sa: Integer;
  Buflen : Integer;
begin
  if (AmpTarget<=AmpQuiet)then exit;

  Data := ptr;
  Buflen := Len;

  while (BufLen > 0) do
  begin
    s  := Trunc(Data^ * FAmpStuff.gain);
    sa := Abs(s);
    if abs(data^) < ampquiet then
      Inc(FAmpStuff.quiet)        // sample is below quiet level
    else
      FAmpStuff.quiet := 0;

    if sa < amptarget then        // amplified level is below target
    begin
      if sa > FAmpStuff.High then FAmpStuff.High := sa;
        Inc(FAmpStuff.Count);

      if FAmpStuff.Count > FAmpStuff.delay then              // been below target for a while
      begin
        if FAmpStuff.quiet > FAmpStuff.delay then            // it's quiet, go back towards normal level
        begin
          FAmpStuff.gain := FAmpStuff.gain + (10 * amprate * (1 - FAmpStuff.gain));
        end
        else
        begin
          // increase amp
          FAmpStuff.gain := FAmpStuff.gain + (amprate * (amptarget / FAmpStuff.High));
          FAmpStuff.High  := 0;
          FAmpStuff.Count := 0;                           // reset counts
        end;
      end;
    end
    else
    begin                                     // amplified level is above target
      if s < -32760 then
        s := -32760
      else
        if s > 32760 then s := 32760;

      FAmpStuff.gain  := FAmpStuff.gain - (amprate * (sa / amptarget)); // decrease amp
      FAmpStuff.High  := 0;
      FAmpStuff.Count := 0;
    end;
    data^ := Smallint(s);                          // replace original sample with amplified version
    Inc(Data);
    Dec(Buflen, 2);
  end;
end;

end.
